/*
 * Route.h
 *
 *  Created on: 2011.04.13.
 *      Author: Imi
 */

#ifndef ROUTE_H_
#define ROUTE_H_

#include<FBase.h>
#include<FSystem.h>
#include"Node.h"
#include"Item.h"
#include"PriorityQueue.h"

using namespace Osp::Base;
using namespace Osp::Base::Collection;
using namespace Osp::Base::Utility;

class Route {
private:
	HashMap* Nodes;
	HashMap* Goods;
	LinkedList* Checkouts;
	HashMap* Architecture;
	LinkedList* CartNodes;//<Integer*>

	Integer Start;
	Integer Destination;

	void CollectCartNodes(void);
	void WriteArchitectDistances(void);
	result CreateAdjacencyMatrix(void);
	result ForetellDestination(void);
	result CreateP2PRoutes(void);
	result CreateOptimalOrder(void);
	result CorrectCheckout(void);
	result RefineOptimalOrder(void);

	MapEntry* GetP2PRouteN(Integer from, Integer to);
	MapEntry* GetReversedP2PRouteN(MapEntry* Route);


	double Distance(const Osp::Graphics::Point& point1, const Osp::Graphics::Point& point2);




public:
	LinkedList* Cart;//<String*>
	HashMap* P2PRoutes;//<LinkedList*, Double*>

	Double* TotalDistance;
	Double* DistanceLeft;
	TimeSpan* TimeLeft;
	DateTime* CheckoutTime, *NavigationStart, *NavigationFinish;

	HashMap* AdjacencyMatrix;//<Integer*,HashMap<Integer*, Double*>>
	ArrayList* OptimalOrder;//<Integer*>

	Route(HashMap* NodesMap, HashMap* GoodsMap, LinkedList* CheckoutsList, HashMap* ArchitectureMap);
	virtual ~Route();

	result PlanRoute(void);

	Double GetP2PDistance(const Integer from, const Integer to);
	LinkedList* GetP2PList(const Integer from, const Integer to);
	LinkedList* GetCartGoodsInCartNodeN(const Integer NodeId);

	void CalculateTotalDistance(void);
	void CalculateTimeLeft(void);
};

#endif /* ROUTE_H_ */
