/*
 * shop.h
 *
 *  Created on: 2011.03.23.
 *      Author: Imi
 */

#ifndef SHOP_H_
#define SHOP_H_

#include<FBase.h>
#include<FGraphics.h>
#include<FIo.h>
#include"Item.h"
#include"Node.h"
#include"Route.h"

using namespace Osp::Base;
using namespace Osp::Base::Collection;
using namespace Osp::Io;
using namespace Osp::Base::Utility;




class shop {
private:

	result PParseItem(const String item_str, Item* item);
	Integer PAddItemstoNode(const String items_row_str, Node* node);
	result PParseCorridorFromFile(File* Fajl, int& NodeId);
	Boolean IsGoodsinNode(const String goods_str);
	Boolean ContainsNodeByCoordinate(const int x, const int y, Integer* node_id);
//	Float GetArchitectDistance(const Integer from, const Integer to);
	result SetArchitectDistance(const Integer i, const Integer j, const Double distance);

	int ImportLineNumber;


	void WriteArchitectDistances(void);
	void WriteItems(void);


	bool IsCartItemstInShop(void);
	void WriteNodes(void);


public:
	shop();
	virtual ~shop();

	Osp::Graphics::Rectangle* Base;
	Route* Navigation;
	HashMap* Nodes;//<Integer*, Node*>
	LinkedList* Checkouts;//<Integer*>
	String Name;
	String Address;
	HashMap* Goods;//<String*, Item*>
	HashMap* Architecture;//<Integer*,HashMap<Integer*, Double*>>

	double Distance(const Osp::Graphics::Point& point1, const Osp::Graphics::Point& point2);
	result MoveItem(const String what, const String where);
	result DeleteItem(const String item);
	result NewItem(const String name, const String place);

	result ParseFromFile(File* Fajl);
	result SaveInfoToFile(File* Fajl);
	result SaveItemsToFile(File* Fajl);
	result SaveNodesToFile(File* Fajl);
	result SaveCheckoutsToFile(File* Fajl);
	result SaveArchitectureToFile(File* Fajl);
	Boolean PExpectFromFile(File* Fajl, String& read, const Boolean check, const String expected=L"", const String delimiters=L" \n\r\t\f");


	result LoadInfoFromFile(File* Fajl);
	result LoadItemsFromFile(File* Fajl);
	result LoadNodesFromFile(File* Fajl);
	result LoadCheckoutsFromFile(File* Fajl);
	result LoadArchitectureFromFile(File* Fajl);



};

#endif /* SHOP_H_ */
