#include "NavigationForm.h"

using namespace Osp::Base;
using namespace Osp::Ui;
using namespace Osp::Ui::Controls;
using namespace Osp::Graphics;
using namespace Osp::Base::Collection;

NavigationForm::NavigationForm(void)
{
}

NavigationForm::~NavigationForm(void)
{
	  delete pCanvas;
}

bool
NavigationForm::Initialize(String id)
{
	// Construct an XML form
	Construct(id);
	return true;
}

result
NavigationForm::OnInitializing(void)
{
	result r = E_SUCCESS;
	drawRect = Rectangle(10, 100, 460, 650);
	__pProgress = static_cast<Progress*>(GetControl(L"IDC_NF_PROGRESS"));
	__pPositionLabel = static_cast<Label*>(GetControl(L"IDC_NF_POSITIONLABEL"));
	__pItemLabel = static_cast<Label*>(GetControl(L"IDC_NF_ITEMLABEL"));
	__pDistLabel = static_cast<Label*>(GetControl(L"IDC_NF_DISTLABEL"));
	__pArrivalLabel = static_cast<Label*>(GetControl(L"IDC_NF_ARRIVALLABEL"));
	__pApplication = Osp::App::Application::GetInstance();
	__pAppResource = __pApplication->GetAppResource();

	position_index = 0;

	pCanvas = GetCanvasN(drawRect);
	return r;
}

void NavigationForm::DrawData(void)
{

	   __pProgress->SetRange(0,__pShop->Navigation->OptimalOrder->GetCount()-1);
	   UpdateDataToIndex(1);

   if (pCanvas)
   {
	   //pCanvas->Clear();

	   pCanvas->DrawBitmap(Point(0,0), * Osp::App::Application::GetInstance()->GetAppResource()->GetBitmapN(L"shopsmart_bricks.png"));
	   int x1, x2, y1, y2, dx1, dx2, dy1, dy2;

	  IMapEnumerator* enumkulso = __pShop->Navigation->AdjacencyMatrix->GetMapEnumeratorN();
	  enumkulso->Reset();
	  while(enumkulso->MoveNext()==E_SUCCESS){
		  x1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(enumkulso->GetKey())))->Coordinate.x;
		  y1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(enumkulso->GetKey())))->Coordinate.y;
		 AppLog("x1=%d, y1=%d", x1, y1);

		  dx1 = DrawX(x1);
		  dy1 = DrawY(y1);




		  IMapEnumerator* enumbelso = static_cast<HashMap*>(enumkulso->GetValue())->GetMapEnumeratorN();
		  enumbelso->Reset();
		  while(enumbelso->MoveNext()==E_SUCCESS){
			  x2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(enumbelso->GetKey())))->Coordinate.x;
			  y2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(enumbelso->GetKey())))->Coordinate.y;
			  AppLog("x2=%d, y2=%d", x2, y2);

			  dx2 = DrawX(x2);
			  dy2 = DrawY(y2);


			  pCanvas->SetLineWidth(10);
			  pCanvas->SetLineStyle(LINE_STYLE_SOLID);
			  pCanvas->SetForegroundColor(Color::COLOR_BLACK);
			  pCanvas->DrawLine(Point(dx1, dy1), Point(dx2, dy2));

		  }
		  delete enumbelso;
	  }
	  delete enumkulso;

	  //Draw the shopping route

	  pCanvas->SetLineWidth(5);
	  pCanvas->SetLineStyle(LINE_STYLE_SOLID);
	  pCanvas->SetForegroundColor(Color::COLOR_GREEN);

	  for(int i = 0; i<=__pShop->Navigation->OptimalOrder->GetCount()-2;i++){
		  LinkedList* path = __pShop->Navigation->GetP2PList(*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(i)),*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(i+1)));

		  for(int j = 0; j <= path->GetCount()-2; j++){
			  x1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j))))->Coordinate.x;
			  y1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j))))->Coordinate.y;
			  x2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j+1))))->Coordinate.x;
			  y2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j+1))))->Coordinate.y;
			  dx1 = DrawX(x1);
			  dy1 = DrawY(y1);
			  dx2 = DrawX(x2);
			  dy2 = DrawY(y2);
			  pCanvas->DrawLine(Point(dx1, dy1), Point(dx2, dy2));
			  if(j == path->GetCount()-2)
				  pCanvas->FillRectangle(Color::COLOR_GREEN, Rectangle(dx2-5, dy2-5, 10, 10));
		  }
	  }

	  //Draw the entrance
	  x1 = static_cast<Node*>(__pShop->Nodes->GetValue(Integer(0)))->Coordinate.x;
	  y1 = static_cast<Node*>(__pShop->Nodes->GetValue(Integer(0)))->Coordinate.y;
	  dx1 = DrawX(x1);
	  dy1 = DrawY(y1);
	  pCanvas->FillRectangle(Color::COLOR_CYAN, Rectangle(dx1-10, dy1-10, 20, 20));


	  IEnumerator* enumcheckouts = __pShop->Checkouts->GetEnumeratorN();
	  enumcheckouts->Reset();
	  while(enumcheckouts->MoveNext()==E_SUCCESS){
		  x1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(enumcheckouts->GetCurrent())))->Coordinate.x;
		  y1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(enumcheckouts->GetCurrent())))->Coordinate.y;
		  dx1 = DrawX(x1);
		  dy1 = DrawY(y1);
		  pCanvas->FillRectangle(Color::COLOR_MAGENTA, Rectangle(dx1-10, dy1-10, 20, 20));
	  }
	  delete enumcheckouts;

	  position_index = 0;

	  pCanvas->SetForegroundColor(Color::COLOR_YELLOW);

	  LinkedList* path = __pShop->Navigation->GetP2PList(*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position_index)),*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position_index+1)));
	  for(int j = 0; j <= path->GetCount()-2; j++){
		  x1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j))))->Coordinate.x;
		  y1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j))))->Coordinate.y;
		  x2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j+1))))->Coordinate.x;
		  y2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j+1))))->Coordinate.y;
		  dx1 = DrawX(x1);
		  dy1 = DrawY(y1);
		  dx2 = DrawX(x2);
		  dy2 = DrawY(y2);
		  pCanvas->DrawLine(Point(dx1, dy1), Point(dx2, dy2));
		  if(j == path->GetCount()-2)
			  pCanvas->FillRectangle(Color::COLOR_RED, Rectangle(dx2-5, dy2-5, 10, 10));
	  }
	  //pCanvas->Show();

   }
}

result
NavigationForm::OnDraw(void)
{
	result r = E_SUCCESS;
	DrawData();
	return r;
}

void NavigationForm::DrawNextData(void)
{
	int x1, x2, y1, y2, dx1, dx2, dy1, dy2;
		pCanvas->SetLineWidth(5);
		pCanvas->SetLineStyle(LINE_STYLE_SOLID);
		pCanvas->SetForegroundColor(Color::COLOR_GREY);

		LinkedList* path = __pShop->Navigation->GetP2PList(*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position_index)),*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position_index+1)));

		  for(int j = 0; j <= path->GetCount()-2; j++){
			  x1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j))))->Coordinate.x;
			  y1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j))))->Coordinate.y;
			  x2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j+1))))->Coordinate.x;
			  y2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j+1))))->Coordinate.y;
			  dx1 = DrawX(x1);
			  dy1 = DrawY(y1);
			  dx2 = DrawX(x2);
			  dy2 = DrawY(y2);
			  pCanvas->DrawLine(Point(dx1, dy1), Point(dx2, dy2));
			  if(j==0)
				  pCanvas->FillRectangle(Color::COLOR_GREY, Rectangle(dx1-5, dy1-5, 10, 10));
			  if(j == path->GetCount()-2)
				  pCanvas->FillRectangle(Color::COLOR_GREY, Rectangle(dx2-5, dy2-5, 10, 10));
		  }

		  position_index++;


	  pCanvas->SetForegroundColor(Color::COLOR_YELLOW);

	  path = __pShop->Navigation->GetP2PList(*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position_index)),*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position_index+1)));
	  for(int j = 0; j <= path->GetCount()-2; j++){
		  x1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j))))->Coordinate.x;
		  y1 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j))))->Coordinate.y;
		  x2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j+1))))->Coordinate.x;
		  y2 = static_cast<Node*>(__pShop->Nodes->GetValue(*static_cast<Integer*>(path->GetAt(j+1))))->Coordinate.y;
		  dx1 = DrawX(x1);
		  dy1 = DrawY(y1);
		  dx2 = DrawX(x2);
		  dy2 = DrawY(y2);
		  pCanvas->DrawLine(Point(dx1, dy1), Point(dx2, dy2));
		  if(j == path->GetCount()-2)
			  pCanvas->FillRectangle(Color::COLOR_RED, Rectangle(dx2-5, dy2-5, 10, 10));
	  }


	  pCanvas->Show();

	  UpdateDataToIndex(position_index+1);

}

void NavigationForm::UpdateDataToIndex(const int position)
{
	__pProgress->SetValue(position);
	  __pProgress->RequestRedraw(true);
	  String a;
	   a.Format(10,L"%d/%d", __pProgress->GetValue(), __pShop->Navigation->OptimalOrder->GetCount()-1);
	   __pPositionLabel->SetText(a);
	   __pPositionLabel->RequestRedraw(true);

	   LinkedList* items = __pShop->Navigation->GetCartGoodsInCartNodeN(*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position)));
	   IEnumerator* enumitems = items->GetEnumeratorN();
	   enumitems->Reset();
	   if(enumitems->MoveNext()==E_SUCCESS)
	   {
			   a = *static_cast<String*>(enumitems->GetCurrent());
		   while(enumitems->MoveNext()==E_SUCCESS){
			   a.Append(L", ");
			   a.Append(*static_cast<String*>(enumitems->GetCurrent()));
		   }
	   } else {
		   a = L"PÉNZTÁR";
	   }
	   delete enumitems;
	   delete items;

	   __pItemLabel->SetText(a);
	   __pItemLabel->RequestRedraw(true);

	   double distance = __pShop->Navigation->GetP2PDistance(*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position-1)),*static_cast<Integer*>(__pShop->Navigation->OptimalOrder->GetAt(position))).ToDouble();
	   a.Format(10, L"%d m", Double(Math::Round(distance)).ToInt());
	   __pDistLabel->SetText(a);
	   __pDistLabel->RequestRedraw(true);

	   *__pShop->Navigation->DistanceLeft = __pShop->Navigation->DistanceLeft->ToDouble() - distance;
	   __pShop->Navigation->CalculateTimeLeft();

	   __pShop->Navigation->CheckoutTime->ToString().SubString(11, a);
	   __pArrivalLabel->SetText(a);
	   __pArrivalLabel->RequestRedraw(true);

	   if(position >= __pShop->Navigation->OptimalOrder->GetCount()-1){
			if (__pAppResource){
				__pAppResource->GetString(L"IDS_NF_SOFTEND", a);
			}
			this->SetSoftkeyText(SOFTKEY_1, a);
		} else {
			if (__pAppResource){
				__pAppResource->GetString(L"IDS_NF_SOFTNEXT", a);
			}
			this->SetSoftkeyText(SOFTKEY_1, a);
		}
	   this->SetSoftkeyEnabled(SOFTKEY_1, true);

}

int NavigationForm::DrawX(int ShopX)
{
	return ((drawRect.width - drawRect.x) / __pShop->Base->width) * ShopX;
}
int NavigationForm::DrawY(int ShopY)
{
	return ((drawRect.height - drawRect.y) / __pShop->Base->height) * ShopY;
}

void
NavigationForm::ReloadData(shop* pShop)
{
	__pShop = pShop;

}

result
NavigationForm::OnTerminating(void)
{
	result r = E_SUCCESS;
	return r;
}

void
NavigationForm::OnActionPerformed(const Osp::Ui::Control& source, int actionId)
{
	switch(actionId)
	{
		default:
			AppLog("Form mondja: %d", actionId);
		break;
	}
}
