/*
 * PriorityQueue.cpp
 *
 *  Created on: 2011.04.06.
 *      Author: Imi
 */

#include "PriorityQueue.h"

NodePriorityQueue::NodePriorityQueue(const Integer destination, HashMap* NodeAttribs) {
	// TODO Auto-generated constructor stub
	list = new LinkedList();
	target = destination;
	Nodes = NodeAttribs;
}

NodePriorityQueue::~NodePriorityQueue() {
	// TODO Auto-generated destructor stub
	list->RemoveAll(false);
	delete list;
}

int NodePriorityQueue::GetManhattanDistance(const Node *node1, const Node *node2){
	int x = Osp::Base::Utility::Math::Abs(node1->Coordinate.x-node2->Coordinate.x);
	int y = Osp::Base::Utility::Math::Abs(node1->Coordinate.y-node2->Coordinate.y);
	return x+y;
}

result NodePriorityQueue::Enqueue(const Integer node){
	result r = E_SUCCESS;
	if (list->GetCount()==0){
		r = list->Add(*new Integer(node));
		int dist_node = GetManhattanDistance(static_cast<Node*>(Nodes->GetValue(node)),static_cast<Node*>(Nodes->GetValue(target)));
		//AppLog("PriorityQueue: %d node Manhattan distance from %d = %d", static_cast<Node*>(Nodes->GetValue(node))->Id.ToInt(),static_cast<Node*>(Nodes->GetValue(target))->Id.ToInt(),dist_node);
		return r;
	}
	IEnumerator* listenum = list->GetEnumeratorN();
	listenum->Reset();
	bool found = false;
	int index;
	int dist_node, dist_current;
	dist_node = GetManhattanDistance(static_cast<Node*>(Nodes->GetValue(node)),static_cast<Node*>(Nodes->GetValue(target)));
	//AppLog("PriorityQueue: %d node Manhattan distance from %d = %d", static_cast<Node*>(Nodes->GetValue(node))->Id.ToInt(),static_cast<Node*>(Nodes->GetValue(target))->Id.ToInt(),dist_node);
	while(found==false && listenum->MoveNext()==E_SUCCESS){

			list->IndexOf(*listenum->GetCurrent(),index);
			dist_current = GetManhattanDistance(static_cast<Node*>(Nodes->GetValue(*static_cast<Integer*>(listenum->GetCurrent()))),static_cast<Node*>(Nodes->GetValue(target)));

			found = dist_node <= dist_current;
	}
	if (found){
		r = list->InsertAt(*new Integer(node),index);
		//AppLog("PriorityQueue: %d node inserted to index %d",static_cast<Node*>(Nodes->GetValue(node))->Id.ToInt(),index);
	} else {
		r = list->InsertAt(*new Integer(node),list->GetCount());
		//AppLog("PriorityQueue: %d node inserted to index %d",static_cast<Node*>(Nodes->GetValue(node))->Id.ToInt(),list->GetCount()-1);
	}
	delete listenum;
	return r;
}

Integer NodePriorityQueue::Dequeue(void){
	Integer pnode;
	if (list->GetCount()==0)
		return null;
	pnode = *static_cast<Integer*>(list->GetAt(0));
	list->RemoveAt(0,true);
	//AppLog("NodePriorityQueue: %d node dequeued", pnode.ToInt());
	return pnode;
}

bool NodePriorityQueue::IsEmpty(void){
	return list->GetCount()==0;
}
