/*
 * Route.cpp
 *
 *  Created on: 2011.04.13.
 *      Author: Imi
 */

#include "Route.h"

Route::Route(HashMap* NodesMap, HashMap* GoodsMap, LinkedList* CheckoutsList, HashMap* ArchitectureMap) {
	// TODO Auto-generated constructor stub
	Nodes = NodesMap;
	Goods = GoodsMap;
	Checkouts = CheckoutsList;
	Architecture = ArchitectureMap;

	Start = 0;

	TimeLeft = new TimeSpan(0);
	CheckoutTime = new DateTime();
	NavigationStart = new DateTime();
	NavigationFinish = new DateTime();
	TotalDistance = 0;
	DistanceLeft = 0;

	Cart = new LinkedList;
	CartNodes = new LinkedList;
	P2PRoutes = new HashMap;
	P2PRoutes->Construct();
	OptimalOrder = new ArrayList;
	OptimalOrder->Construct();
	AdjacencyMatrix = new HashMap;
	AdjacencyMatrix->Construct();
}

Route::~Route() {
	// TODO Auto-generated destructor stub
	delete TimeLeft;
	delete CheckoutTime;
	delete TotalDistance;
	delete DistanceLeft;

	Cart->RemoveAll();
	delete Cart;
	CartNodes->RemoveAll(true);
	delete CartNodes;

	/*IMapEnumerator* enumP2P = P2PRoutes->GetMapEnumeratorN();
	while(enumP2P->MoveNext()==E_SUCCESS){
		static_cast<LinkedList*>(enumP2P->GetKey())->RemoveAll(true);
	}
	delete enumP2P;*/
	P2PRoutes->RemoveAll(true);
	delete P2PRoutes;

	OptimalOrder->RemoveAll(true);
	delete OptimalOrder;

	/*IMapEnumerator* arcenum = AdjacencyMatrix->GetMapEnumeratorN();
	arcenum->Reset();
	while(arcenum->MoveNext()==E_SUCCESS){
		static_cast<HashMap*>(arcenum->GetValue())->RemoveAll(true);
	}
	delete arcenum;*/
	AdjacencyMatrix->RemoveAll(true);
	delete AdjacencyMatrix;
}

void Route::CollectCartNodes(void){
	CartNodes->RemoveAll(true);//Empty the CartNodes
	IEnumerator* cartenum = Cart->GetEnumeratorN();
	cartenum->Reset();
	bool exist;
	while(cartenum->MoveNext()==E_SUCCESS){
		Goods->ContainsKey(*cartenum->GetCurrent(),exist);
		if (exist==false){//If this item does not exist in that shop
			AppLog("*** CollectCartNodes: %S item not exists among Goods!", static_cast<String*>(cartenum->GetCurrent())->GetPointer());
		} else {//If item exists in the shop
			String* currGood = static_cast<String*>(cartenum->GetCurrent());//Cast the current good name
			Integer* currNode = new Integer(static_cast<Item*>(Goods->GetValue(*currGood))->Container);//get the container id
			if (CartNodes->Contains(*currNode)==false){//If id is not among CartNodes
				CartNodes->Add(*currNode);//Add it
			}
		}
	}
	delete cartenum;
}

result Route::CreateAdjacencyMatrix(void){
	result r = E_SUCCESS;
	//Delete the previous AdjacencyMatrix
	IMapEnumerator* adjenum = AdjacencyMatrix->GetMapEnumeratorN();
	adjenum->Reset();
	while(adjenum->MoveNext()==E_SUCCESS){
		static_cast<HashMap*>(adjenum->GetValue())->RemoveAll(true);
	}
	delete adjenum;
	AdjacencyMatrix->RemoveAll(true);
	//delete AdjacencyMatrix;

	//Create the new one
	//AdjacencyMatrix = new HashMap;
	//AdjacencyMatrix->Construct();

	//Copy the Architecture into the AdjacencyMatrix
	IMapEnumerator* kulsoenum = Architecture->GetMapEnumeratorN();
	kulsoenum->Reset();
	while(kulsoenum->MoveNext()==E_SUCCESS){
		Integer* kulsokulcs = new Integer(*static_cast<Integer*>(kulsoenum->GetKey()));
		HashMap* kulsoertek = new HashMap;
		kulsoertek->Construct();
		IMapEnumerator* belsoenum = static_cast<HashMap*>(kulsoenum->GetValue())->GetMapEnumeratorN();
		belsoenum->Reset();
		while(belsoenum->MoveNext()==E_SUCCESS){
			Integer* belsokulcs = new Integer(*static_cast<Integer*>(belsoenum->GetKey()));
			Double* belsoertek = new Double(*static_cast<Double*>(belsoenum->GetValue()));
			kulsoertek->Add(*belsokulcs,*belsoertek);
		}
		delete belsoenum;
		AdjacencyMatrix->Add(*kulsokulcs,*kulsoertek);
	}
	delete kulsoenum;

	//Clear the matrix


	IMapEnumerator* nodesenum = Nodes->GetMapEnumeratorN();
	nodesenum->Reset();
	while(nodesenum->MoveNext()==E_SUCCESS){
		/*AppLog("NEW ROUND!");
		WriteArchitectDistances();
		Osp::Base::Runtime::Thread::Sleep(1000);*/
		if(static_cast<Node*>(nodesenum->GetValue())->IsJunction==false && CartNodes->Contains(*static_cast<Integer*>(nodesenum->GetKey()))==false){
			HashMap* neighborMap = static_cast<HashMap*>(AdjacencyMatrix->GetValue(*static_cast<Integer*>(nodesenum->GetKey())));
			IMapEnumerator* neighborenum = neighborMap->GetMapEnumeratorN();
			neighborenum->Reset();
			if(neighborenum->MoveNext()!=E_SUCCESS){//If somehow the inner node does not have neighbours
				AppLog("*** AdjacencyMatrixCreator: Cannot get neighbor of the node %d!",static_cast<Integer*>(nodesenum->GetKey())->ToInt());
				return E_OUT_OF_RANGE;
			}
			Integer* neighborNodeId1 = new Integer(*static_cast<Integer*>(neighborenum->GetKey()));
			if(neighborenum->MoveNext()!=E_SUCCESS){//If somehow the inner node does not have neighbours
				AppLog("*** AdjacencyMatrixCreator: Cannot get neighbor of the node %d!",static_cast<Integer*>(nodesenum->GetKey())->ToInt());
				return E_OUT_OF_RANGE;
			}
			Integer* neighborNodeId2 = new Integer(*static_cast<Integer*>(neighborenum->GetKey()));
			delete neighborenum;

			/*AppLog("BEFORE DELETE!");
					WriteArchitectDistances();
					Osp::Base::Runtime::Thread::Sleep(1000);*/

			Integer* rem =  new Integer(*static_cast<Integer*>(nodesenum->GetKey()));
						/*AppLog("Remove: %d", rem->ToInt());
						Osp::Base::Runtime::Thread::Sleep(1000);*/


			//Remove and deallocate distance attributes of the node being deleted
			neighborMap->RemoveAll(true);
			//neighborMap->Remove(*neighborNodeId1,true);
			//neighborMap->Remove(*neighborNodeId2,true);
			AdjacencyMatrix->Remove(*nodesenum->GetKey(),true);

			/*AppLog("AFTER DELETE TARGET:");
					WriteArchitectDistances();
					Osp::Base::Runtime::Thread::Sleep(1000);*/

			//Remove the distance attributes at neighbors to the node being deleted

			static_cast<HashMap*>(AdjacencyMatrix->GetValue(*neighborNodeId1))->Remove(*rem,true);
			static_cast<HashMap*>(AdjacencyMatrix->GetValue(*neighborNodeId2))->Remove(*rem,true);

			//Get the neighbor nodes
			Node* neighborNode1, *neighborNode2;
			neighborNode1 = static_cast<Node*>(Nodes->GetValue(*neighborNodeId1));
			neighborNode2 = static_cast<Node*>(Nodes->GetValue(*neighborNodeId2));

			//Calculate the distance between the neighbors
			Double* dist_neighbor = new Double(Distance(neighborNode1->Coordinate,neighborNode2->Coordinate));

			//Add the distance entries
			static_cast<HashMap*>(AdjacencyMatrix->GetValue(*neighborNodeId1))->Add(*neighborNodeId2,*dist_neighbor);

			dist_neighbor = new Double(Distance(neighborNode1->Coordinate,neighborNode2->Coordinate));
			static_cast<HashMap*>(AdjacencyMatrix->GetValue(*neighborNodeId2))->Add(*neighborNodeId1,*dist_neighbor);


			/*AppLog("AFTER ROUND:");
			WriteArchitectDistances();
			Osp::Base::Runtime::Thread::Sleep(1000);*/
			delete rem;
		}
	}
	delete nodesenum;

	return r;
}

result Route::ForetellDestination(void)
{
	result r = E_SUCCESS;
	Node* StartNode = static_cast<Node*>(Nodes->GetValue(* new Integer(0)));

	//Get the farthest cartnode's distance
	if (CartNodes->GetCount()==0){
		AppLog("*** DestinationForeteller: Empty CartNodes!");
		return E_INVALID_CONTENT;
	}
	IEnumerator* enumCartNodes = CartNodes->GetEnumeratorN();
	enumCartNodes->Reset();
	enumCartNodes->MoveNext();
	double HiDist = Distance(StartNode->Coordinate,static_cast<Node*>(Nodes->GetValue(*static_cast<Integer*>(enumCartNodes->GetCurrent())))->Coordinate);
	while(enumCartNodes->MoveNext()==E_SUCCESS){
		double currDist = Distance(StartNode->Coordinate,static_cast<Node*>(Nodes->GetValue(*static_cast<Integer*>(enumCartNodes->GetCurrent())))->Coordinate);
		if (currDist > HiDist){
			HiDist = currDist;
		}
	}

	//Make the list of cartnodes which are not closer to the entrance than the farthest cartnode - 10

	LinkedList* FarthestCartNodes = new LinkedList;
	enumCartNodes->Reset();
	while(enumCartNodes->MoveNext()==E_SUCCESS){
		double currDist = Distance(StartNode->Coordinate,static_cast<Node*>(Nodes->GetValue(*static_cast<Integer*>(enumCartNodes->GetCurrent())))->Coordinate);
		if (currDist >= HiDist - 10){
			FarthestCartNodes->Add(*enumCartNodes->GetCurrent());
		}
	}

	delete enumCartNodes;

	//Find the optimal checkout, which has the lowest distance to the cartnode closest to the checkouts

	IEnumerator* enumCheckouts = Checkouts->GetEnumeratorN();
	enumCheckouts->Reset();
	IEnumerator* enumFarthestCartNodes = FarthestCartNodes->GetEnumeratorN();
	enumFarthestCartNodes->Reset();
	enumCheckouts->MoveNext();
	enumFarthestCartNodes->MoveNext();

	double LoDist = Distance(static_cast<Node*>(Nodes->GetValue(*static_cast<Integer*>(enumCheckouts->GetCurrent())))->Coordinate,static_cast<Node*>(Nodes->GetValue(*static_cast<Integer*>(enumFarthestCartNodes->GetCurrent())))->Coordinate);
	Destination = *static_cast<Integer*>(enumCheckouts->GetCurrent());

	enumCheckouts->Reset();

	while(enumCheckouts->MoveNext()==E_SUCCESS){
		enumFarthestCartNodes->Reset();
		while(enumFarthestCartNodes->MoveNext()==E_SUCCESS){
			double currDist = Distance(static_cast<Node*>(Nodes->GetValue(*static_cast<Integer*>(enumCheckouts->GetCurrent())))->Coordinate,static_cast<Node*>(Nodes->GetValue(*static_cast<Integer*>(enumFarthestCartNodes->GetCurrent())))->Coordinate);
			if (currDist < LoDist){
				LoDist = currDist;
				Destination = *static_cast<Integer*>(enumCheckouts->GetCurrent());
			}
		}
	}

	delete enumCheckouts;
	delete enumFarthestCartNodes;
	delete FarthestCartNodes;

	return r;
}

MapEntry* Route::GetP2PRouteN(Integer from, Integer to)
{
	LinkedList G;//The SearchGraph
	NodePriorityQueue* OPEN = new NodePriorityQueue(to, Nodes);
	HashMap DISTANCE;
	DISTANCE.Construct();
	HashMap PARENT;
	PARENT.Construct();

	//INIT
	G.Add(*new Integer(from));//G<-{s}
	DISTANCE.Add(*new Integer(from),*new Integer(0));//g(s)<-0
	PARENT.Add(*new Integer(from),*new Integer(-1));//p(s)<-nil
	Integer* n = new Integer(from);//n<-s
	OPEN->Enqueue(*new Integer(*n));


	//ALGO

	while(/*OPEN->IsEmpty()==false && */n->Equals(to)==false){//while not(ures(NYÍLT)) and not(cel(n))
		if (n->Equals(from))
			OPEN->Dequeue();//NYÍLT <- NYILT \ {s}
		HashMap* cn = static_cast<HashMap*>(AdjacencyMatrix->GetValue(*n));//c(n,_)
		IMapEnumerator* M = cn->GetMapEnumeratorN();//M <- GAMMA(n)
		M->Reset();
		while(M->MoveNext()==E_SUCCESS){//while not üres(M)
			Integer* m = static_cast<Integer*>(M->GetKey());//m <- eleme(M)
			Double* summa = new Double(static_cast<Double*>(DISTANCE.GetValue(*n))->ToDouble() + static_cast<Double*>(cn->GetValue(*m))->ToDouble());//g(n)+c(n,m)
			if(G.Contains(*m)==false || static_cast<Double*>(DISTANCE.GetValue(*m))->ToDouble() > summa->ToDouble()){
				bool g;
				DISTANCE.ContainsKey(*m,g);
				if (g==false){
					DISTANCE.Add(*new Integer(*m), *summa);
				} else {
					DISTANCE.SetValue(*m, *summa, true);
				}

				bool p;
				PARENT.ContainsKey(*m,p);
				if(p==false){
					PARENT.Add(*new Integer(*m),*new Integer(*n));
				} else {
					PARENT.SetValue(*m,*new Integer(*n),true);
				}

				OPEN->Enqueue(*m);//NYÍLT <- NYÍLT U {m}
				G.Add(*new Integer(*m));//G <- G U {m}
			}

		}
		*n = OPEN->Dequeue();//n <- minf(NYÍLT)
		delete M;
	}
	//COUNSTRUCT THE ROUTE

	LinkedList* path = new LinkedList;
	Integer* p = new Integer(to);
	while(p->Equals(*new Integer(-1))==false){
		path->InsertAt(* new Integer(*p),0);
		p = static_cast<Integer*>(PARENT.GetValue(*p));
	}
	Double* d = new Double(*static_cast<Double*>(DISTANCE.GetValue(to)));
	MapEntry* mp = new MapEntry(*path,*d);

	//Garbage collection
	delete OPEN;
	delete n;
	G.RemoveAll(true);
	DISTANCE.RemoveAll(true);
	PARENT.RemoveAll(true);

	return mp;
}

MapEntry* Route::GetReversedP2PRouteN(MapEntry* Route)
{
	Double* distance = new Double(*static_cast<Double*>(Route->GetValue()));
	LinkedList* path = new LinkedList;

	IEnumerator* enumpath = static_cast<LinkedList*>(Route->GetKey())->GetEnumeratorN();
	enumpath->Reset();
	while(enumpath->MoveNext()==E_SUCCESS){
		path->InsertAt(*new Integer(*static_cast<Integer*>(enumpath->GetCurrent())),0);
	}
	delete enumpath;
	MapEntry* rev_mp = new MapEntry(*path,*distance);
	return rev_mp;
}

result Route::CreateP2PRoutes(void)
{
	result r = E_SUCCESS;

	P2PRoutes->RemoveAll(true);

	//Create the route between the entrance and the destination checkout
	Integer* Entrance = new Integer(0);
	MapEntry* route = GetP2PRouteN(*Entrance, Destination);
	delete Entrance; Entrance = null;
	MapEntry* rev_route = GetReversedP2PRouteN(route);
	P2PRoutes->Add(*route->GetKey(),*route->GetValue());
	P2PRoutes->Add(*rev_route->GetKey(),*rev_route->GetValue());


	//Create the routes to and from the entrance
	IEnumerator* enumCart = CartNodes->GetEnumeratorN();
	enumCart->Reset();

	while(enumCart->MoveNext()==E_SUCCESS){
		Integer* Entrance = new Integer(0);
		MapEntry* route = GetP2PRouteN(*Entrance, *static_cast<Integer*>(enumCart->GetCurrent()));
		delete Entrance; Entrance = null;
		MapEntry* rev_route = GetReversedP2PRouteN(route);
		P2PRoutes->Add(*route->GetKey(),*route->GetValue());
		P2PRoutes->Add(*rev_route->GetKey(),*rev_route->GetValue());
	}

	//Create the routes to and from the destination checkout

	enumCart->Reset();

	while(enumCart->MoveNext()==E_SUCCESS){
		MapEntry* route = GetP2PRouteN(Destination, *static_cast<Integer*>(enumCart->GetCurrent()));
		MapEntry* rev_route = GetReversedP2PRouteN(route);
		P2PRoutes->Add(*route->GetKey(),*route->GetValue());
		P2PRoutes->Add(*rev_route->GetKey(),*rev_route->GetValue());
	}
	//Create the routes from each node to each node

	enumCart->Reset();

	while(enumCart->MoveNext()==E_SUCCESS){
		int index;
		CartNodes->IndexOf(*enumCart->GetCurrent(),index);
		index++;
		while(index < CartNodes->GetCount()){
			MapEntry* route = GetP2PRouteN(*static_cast<Integer*>(CartNodes->GetAt(index)), *static_cast<Integer*>(enumCart->GetCurrent()));
			MapEntry* rev_route = GetReversedP2PRouteN(route);
			P2PRoutes->Add(*route->GetKey(),*route->GetValue());
			P2PRoutes->Add(*rev_route->GetKey(),*rev_route->GetValue());

			index++;
		}
	}

	delete enumCart;

	return r;
}

result Route::CreateOptimalOrder(void)
{
	result r = E_SUCCESS;
	OptimalOrder->RemoveAll(true);

	OptimalOrder->Add(*new Integer(0));//Add the start node
	OptimalOrder->Add(*new Integer(Destination));//Add the destination

	while(CartNodes->GetCount()!=0){
		Double maxDistance = GetP2PDistance(*static_cast<Integer*>(CartNodes->GetAt(0)), *static_cast<Integer*>(OptimalOrder->GetAt(0)));
		Integer CartId = *static_cast<Integer*>(CartNodes->GetAt(0));
		IEnumerator* enumCart = CartNodes->GetEnumeratorN();
		enumCart->Reset();
		IEnumerator* enumOpt = OptimalOrder->GetEnumeratorN();
		enumOpt->Reset();
		//Find the farthest node from the route
		while(enumCart->MoveNext()==E_SUCCESS){
			enumOpt->Reset();
			while(enumOpt->MoveNext()==E_SUCCESS){
				Double currDist = GetP2PDistance(*static_cast<Integer*>(enumCart->GetCurrent()), *static_cast<Integer*>(enumOpt->GetCurrent()));
				if(maxDistance.ToDouble() < currDist.ToDouble()){
					maxDistance = currDist;
					CartId = *static_cast<Integer*>(enumCart->GetCurrent());
				}
			}
		}
		delete enumCart;
		delete enumOpt;
		int index = 0;
		//Find the place, where the distance of the new node from the two neighbour nodes is minimal
		double minDifference = GetP2PDistance(CartId, *static_cast<Integer*>(OptimalOrder->GetAt(index))).ToDouble() + GetP2PDistance(CartId, *static_cast<Integer*>(OptimalOrder->GetAt(index+1))).ToDouble() - GetP2PDistance(*static_cast<Integer*>(OptimalOrder->GetAt(index)), *static_cast<Integer*>(OptimalOrder->GetAt(index+1))).ToDouble();
		for(int i=1;i<OptimalOrder->GetCount()-1;i++){
			double difference = GetP2PDistance(CartId, *static_cast<Integer*>(OptimalOrder->GetAt(i))).ToDouble() + GetP2PDistance(CartId, *static_cast<Integer*>(OptimalOrder->GetAt(i+1))).ToDouble() - GetP2PDistance(*static_cast<Integer*>(OptimalOrder->GetAt(i)), *static_cast<Integer*>(OptimalOrder->GetAt(i+1))).ToDouble();
			if (difference <= minDifference){
				index = i;
				minDifference = difference;
			}
		}
		//Insert the new node between the neighbours
		OptimalOrder->InsertAt(*new Integer(CartId),index+1);
		CartNodes->Remove(CartId,true);

	}

	return r;
}

result Route::RefineOptimalOrder(void)
{
	result r = E_SUCCESS;
	int i = 0;
	while(i < OptimalOrder->GetCount()-2){
		LinkedList* onRoute = GetP2PList(*static_cast<Integer*>(OptimalOrder->GetAt(i)),*static_cast<Integer*>(OptimalOrder->GetAt(i+1)));//get the route corresponding to the node pair
		IEnumerator* enumOnRoute = onRoute->GetEnumeratorN();
		enumOnRoute->Reset();
		while(enumOnRoute->MoveNext()==E_SUCCESS){
			int itIsHereIndex;
			if(OptimalOrder->IndexOf(*static_cast<Integer*>(enumOnRoute->GetCurrent()),i+2,itIsHereIndex)==E_SUCCESS){//If the node is among the nodes to be visited
				OptimalOrder->RemoveAt(itIsHereIndex,true);//remove it
				OptimalOrder->InsertAt(*new Integer(*static_cast<Integer*>(enumOnRoute->GetCurrent())),i+1);//build a list of them
				i++;
			}
		}
		delete enumOnRoute;
		i++;
	}

	return r;
}

result Route::CorrectCheckout(void)
{
	result r = E_SUCCESS;
	if(OptimalOrder->GetCount()<3){//If there were no items to buy on the list
		AppLog("***CheckoutCorrector: OptimalOrder < 3!");
		return E_INVALID_DATA;
	}
	OptimalOrder->RemoveAt(OptimalOrder->GetCount()-1,true);//drop the last nav point

	IEnumerator* enumCheckout = Checkouts->GetEnumeratorN();
	enumCheckout->Reset();

	Double mindistance = Double::GetMaxValue();
	Integer Checkout;
	MapEntry* bestCheckoutRoute;

	while(enumCheckout->MoveNext()==E_SUCCESS){//find the closest checkout and plan the route to it
		MapEntry* route = GetP2PRouteN(*static_cast<Integer*>(OptimalOrder->GetAt(OptimalOrder->GetCount()-1)), *static_cast<Integer*>(enumCheckout->GetCurrent()));
		if(static_cast<Double*>(route->GetValue())->ToDouble() < mindistance.ToDouble()){
			mindistance = static_cast<Double*>(route->GetValue())->ToDouble();
			Checkout = *static_cast<Integer*>(enumCheckout->GetCurrent());
			bestCheckoutRoute = route;
		} else {
			delete route;
		}
	}
	delete enumCheckout;

	OptimalOrder->InsertAt(*new Integer(Checkout), OptimalOrder->GetCount());//Add the checkout as the last nav point
	P2PRoutes->Add(*bestCheckoutRoute->GetKey(),*bestCheckoutRoute->GetValue());//Add the route to it to the routes


	return r;
}

Double Route::GetP2PDistance(const Integer from, const Integer to)
{
	IMapEnumerator* enumP2P = P2PRoutes->GetMapEnumeratorN();
	enumP2P->Reset();
	Double distance = -1.0;
	while(distance.Equals((Double)-1.0) && enumP2P->MoveNext()==E_SUCCESS){
		LinkedList* currRoute = static_cast<LinkedList*>(enumP2P->GetKey());
		if(static_cast<Integer*>(currRoute->GetAt(0))->Equals(from) && static_cast<Integer*>(currRoute->GetAt(currRoute->GetCount()-1))->Equals(to)){
			distance = *static_cast<Double*>(enumP2P->GetValue());
		}
	}
	delete enumP2P;
	return distance;
}

LinkedList* Route::GetP2PList(const Integer from, const Integer to)
{
	IMapEnumerator* enumP2P = P2PRoutes->GetMapEnumeratorN();
	enumP2P->Reset();

	while(enumP2P->MoveNext()==E_SUCCESS){
		LinkedList* currRoute = static_cast<LinkedList*>(enumP2P->GetKey());
		if(static_cast<Integer*>(currRoute->GetAt(0))->Equals(from) && static_cast<Integer*>(currRoute->GetAt(currRoute->GetCount()-1))->Equals(to)){
			delete enumP2P;
			return currRoute;
		}
	}
	delete enumP2P;
	return null;
}

void Route::CalculateTotalDistance(void)
{
	TotalDistance = new Double;
	DistanceLeft = new Double;
	double sumDist = 0;
	for(int i = 0; i<=OptimalOrder->GetCount()-2; i++){
		sumDist += GetP2PDistance(*static_cast<Integer*>(OptimalOrder->GetAt(i)), *static_cast<Integer*>(OptimalOrder->GetAt(i+1))).ToDouble();
	}
	*TotalDistance = sumDist;
	*DistanceLeft = sumDist;
}

void Route::CalculateTimeLeft(void)
{
	delete TimeLeft;
	int dist = Math::Round(DistanceLeft->ToDouble());
	TimeLeft = new TimeSpan(0,0,0,2*dist,0);
	AppLog("%lld Hour %lld Minute %lld Second", TimeLeft->GetHours(), TimeLeft->GetMinutes(), TimeLeft->GetSeconds());
	DateTime currTime;
	Osp::System::SystemTime::SystemTime::GetCurrentTime(Osp::System::WALL_TIME, currTime);
	if(currTime.AddSeconds(2*dist)!=E_SUCCESS)
		AppLog("ROSSZ ÖSSZEADÁS!");
	*CheckoutTime = currTime;
}

LinkedList* Route::GetCartGoodsInCartNodeN(const Integer NodeId)
{
	LinkedList* list = new LinkedList;
	IEnumerator* enumStoredGoods = static_cast<Node*>(Nodes->GetValue(NodeId))->Stored.GetEnumeratorN();
	enumStoredGoods->Reset();
	while(enumStoredGoods->MoveNext()==E_SUCCESS){
		String item = *static_cast<String*>(enumStoredGoods->GetCurrent());
		if(Cart->Contains(item)){
			list->Add(* new String(item));
		}
	}
	delete enumStoredGoods;

	return list;
}


double Route::Distance(const Osp::Graphics::Point& point1, const Osp::Graphics::Point& point2){
	double deltax = (double)(point1.x-point2.x);
	double deltay = (double)(point1.y-point2.y);
	double res = Math::Sqrt(Math::Pow(deltax,2)+Math::Pow(deltay,2));
	return res;
}

void Route::WriteArchitectDistances(void){
	IMapEnumerator* kulso = AdjacencyMatrix->GetMapEnumeratorN();
	kulso->Reset();
	while(kulso->MoveNext()==E_SUCCESS){
		Integer* kulsokulcs;
		kulsokulcs = static_cast<Integer*>(kulso->GetKey());
		HashMap* kulsoertek;
		kulsoertek = static_cast<HashMap*>(kulso->GetValue());
		IMapEnumerator* belso = kulsoertek->GetMapEnumeratorN();
		belso->Reset();
		while(belso->MoveNext()==E_SUCCESS){
			Integer* belsokulcs = static_cast<Integer*>(belso->GetKey());
			Double* belsoertek = static_cast<Double*>(belso->GetValue());
			AppLogDebug("Adjacency[%d][%d]=%f",kulsokulcs->ToInt(),belsokulcs->ToInt(),belsoertek->ToDouble());
		}
		delete belso;
	}
	delete kulso;
}

result Route::PlanRoute(void){
	result r = E_SUCCESS;
	CollectCartNodes();

	r = CreateAdjacencyMatrix();
	if(r==E_SUCCESS)
	r = ForetellDestination();
	if(r==E_SUCCESS)
		r = CreateP2PRoutes();
	if(r==E_SUCCESS)
		r = CreateOptimalOrder();
	if(r==E_SUCCESS)
		r = RefineOptimalOrder();
	if(r==E_SUCCESS)
		r = CorrectCheckout();
	return r;
}
