/**
 * Name        : ShopSmart
 * Version     : 
 * Vendor      : 
 * Description : 
 */


#include "ShopSmart.h"

using namespace Osp::App;
using namespace Osp::Base;
using namespace Osp::System;
using namespace Osp::Ui;
using namespace Osp::Ui::Controls;
using namespace Osp::Io;

ShopSmart::ShopSmart():
__pFrame(null),
__pCURRF(null),
__pNEXTF(null),
__pMainForm(null),
__pFileSelectForm(null),
__pSaveForm(null),
__pItemSelectForm(null),
__pShop(null)
{

}

ShopSmart::~ShopSmart()
{
	delete __pISFOptionMenu;
}

Application*
ShopSmart::CreateInstance(void)
{
	// Create the instance through the constructor.
	return new ShopSmart();
}

bool
ShopSmart::OnAppInitializing(AppRegistry& appRegistry)
{
	// TODO:
	// Initialize UI resources and application specific data.
	// The application's permanent data and context can be obtained from the appRegistry.
	//
	// If this method is successful, return true; otherwise, return false.
	// If this method returns false, the application will be terminated.

	// Uncomment the following statement to listen to the screen on/off events.
	//PowerManager::SetScreenEventListener(*this);

	__pFileListItems = new Osp::Base::Collection::HashMap;
	__pFileListItems->Construct();

	__pSelectItemsListItems = new Osp::Base::Collection::HashMap;
	__pSelectItemsListItems->Construct();

	//************************************************************************************

	__pFrame = GetAppFrame()->GetFrame();

	//*************************************************************************************
	// MainForm
	__pMainForm  = new Form();
	__pMainForm->Construct(L"IDF_MAINFORM");
	__pFrame->AddControl(*__pMainForm);

	Button* pButton = static_cast<Button *>(__pMainForm->GetControl(L"IDC_MAINFORM_BTN1"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_MAINFORM_BTN1);
		pButton->AddActionEventListener(*this);
	}
	pButton = static_cast<Button *>(__pMainForm->GetControl(L"IDC_MAINFORM_BTN2"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_MAINFORM_BTN2);
		pButton->AddActionEventListener(*this);
	}
	pButton = static_cast<Button *>(__pMainForm->GetControl(L"IDC_MAINFORM_BTN3"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_MAINFORM_BTN3);
		pButton->AddActionEventListener(*this);
		pButton->SetEnabled(false);
	}
	pButton = static_cast<Button *>(__pMainForm->GetControl(L"IDC_MAINFORM_BTN4"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_MAINFORM_BTN4);
		pButton->AddActionEventListener(*this);
	}



	//*************************************************************************************
	// FileSelectForm
	__pFileSelectForm  = new Form();
	__pFileSelectForm->Construct(L"IDF_FILESELECTFORM");
	__pFrame->AddControl(*__pFileSelectForm);
	pButton = static_cast<Button *>(__pFileSelectForm->GetControl(L"IDC_FSF_BTN1"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_FILESELECTFORM_BTN1);
		pButton->AddActionEventListener(*this);
	}
	pButton = static_cast<Button *>(__pFileSelectForm->GetControl(L"IDC_FSF_BTN2"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_FILESELECTFORM_BTN2);
		pButton->AddActionEventListener(*this);
	}

	__pFileList = static_cast<List *>(__pFileSelectForm->GetControl(L"IDC_FILELIST"));;

//*********SAVE FORM***************************************************************************

	__pSaveForm  = new Form();
	__pSaveForm->Construct(L"IDF_SAVEFORM");
	__pFrame->AddControl(*__pSaveForm);
	pButton = static_cast<Button *>(__pSaveForm->GetControl(L"IDC_SF_BTOK"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_SAVEFILE_BTNOK);
		pButton->AddActionEventListener(*this);
	}
	pButton = static_cast<Button *>(__pSaveForm->GetControl(L"IDC_SF_BTC"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_SAVEFILE_BTNC);
		pButton->AddActionEventListener(*this);
	}

	__pSaveFileList = static_cast<List *>(__pSaveForm->GetControl(L"IDC_SF_LIST"));
	__pSaveFileList->AddItemEventListener(*this);

	__pSaveFileEdit = static_cast<EditField*>(__pSaveForm->GetControl(L"IDC_SF_EDIT"));

//*********ITEMSELECT FORM***************************************************************************

	__pItemSelectForm  = new Form();
	__pItemSelectForm-> Construct(L"IDF_ITEMSELECT_FORM");
	__pFrame->AddControl(*__pItemSelectForm);

	pButton = static_cast<Button *>(__pItemSelectForm->GetControl(L"IDC_ISF_BTEL"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_ISF_BTEL);
		pButton->AddActionEventListener(*this);
	}

	__pISFCartLabel = static_cast<Label *>(__pItemSelectForm->GetControl(L"IDC_ISF_LABELCOUNT"));
	__pISFLabel = static_cast<Label *>(__pItemSelectForm->GetControl(L"IDC_ISF_LABEL"));

	__pItemSelectForm->SetSoftkeyActionId(SOFTKEY_0, ID_ISF_SOFTMENU);
	__pItemSelectForm->AddSoftkeyActionListener(SOFTKEY_0, *this);
	__pItemSelectForm->SetSoftkeyActionId(SOFTKEY_1, ID_ISF_SOFTPLAN);
	__pItemSelectForm->AddSoftkeyActionListener(SOFTKEY_1, *this);

	__pISFOptionMenu = new OptionMenu();
	__pISFOptionMenu->Construct();
	AppResource *pAppResource = Application::GetAppResource();
	String title;

	if (pAppResource){pAppResource->GetString(L"IDS_ISF_LOAD_CART.text", title);
	__pISFOptionMenu->AddItem(title,ID_ISF_OPT_LOAD_CART);}
	if (pAppResource){pAppResource->GetString(L"IDS_ISF_SAVE_CART.text", title);
	__pISFOptionMenu->AddItem(title,ID_ISF_OPT_SAVE_CART);}
	if (pAppResource){pAppResource->GetString(L"IDS_ISF_DELETE_CART.text", title);
		__pISFOptionMenu->AddItem(title,ID_ISF_OPT_DELETE_CART);}
	if (pAppResource){pAppResource->GetString(L"IDS_ISF_MOVE_ITEM.text", title);
	__pISFOptionMenu->AddItem(title,ID_ISF_OPT_MOVE_ITEM);}
	if (pAppResource){pAppResource->GetString(L"IDS_ISF_NEW_ITEM.text", title);
	__pISFOptionMenu->AddItem(title,ID_ISF_OPT_NEW_ITEM);}
	if (pAppResource){pAppResource->GetString(L"IDS_ISF_DELETE_ITEM.text", title);
		__pISFOptionMenu->AddItem(title,ID_ISF_OPT_DELETE_ITEM);}
	if (pAppResource){pAppResource->GetString(L"IDS_ISF_SAVE_SHOP.text", title);
	__pISFOptionMenu->AddItem(title,ID_ISF_OPT_SAVE_SHOP);}
	if (pAppResource){pAppResource->GetString(L"IDS_ISF_DELETE_SHOP.text", title);
	__pISFOptionMenu->AddItem(title,ID_ISF_OPT_DELETE_SHOP);}
	__pISFOptionMenu->AddActionEventListener(*this);

	__pItemSelectForm->SetOptionkeyActionId(ID_ISF_OPT);
	__pItemSelectForm->AddOptionkeyActionListener(*this);

	//Grouped List
	__pItemSelectList = static_cast<List*>(__pItemSelectForm->GetControl(L"IDC_ISF_LIST"));
	__pItemSelectList->AddItemEventListener(*this);

//*************** CalculatedForm *******************************************
	__pCalculatedForm  = new Form();
	__pCalculatedForm-> Construct(L"IDF_CALCULATEDFORM");
	__pFrame->AddControl(*__pCalculatedForm);

	__pCFShopLabel = static_cast<Label *>(__pCalculatedForm->GetControl(L"IDC_CF_SHOPLABEL"));
	__pCFAddressLabel = static_cast<Label *>(__pCalculatedForm->GetControl(L"IDC_CF_ADDRESSLABEL"));
	__pCFDistanceLabel = static_cast<Label *>(__pCalculatedForm->GetControl(L"IDC_CF_DISTANCELABEL"));
	__pCFDurationLabel = static_cast<Label *>(__pCalculatedForm->GetControl(L"IDC_CF_DURATIONLABEL"));
	__pCFArrivalLabel = static_cast<Label *>(__pCalculatedForm->GetControl(L"IDC_CF_ARRIVALLABEL"));

	__pCalculatedForm->SetSoftkeyActionId(SOFTKEY_0, ID_CF_SOFTCART);
	__pCalculatedForm->AddSoftkeyActionListener(SOFTKEY_0, *this);
	__pCalculatedForm->SetSoftkeyActionId(SOFTKEY_1, ID_CF_SOFTSTART);
	__pCalculatedForm->AddSoftkeyActionListener(SOFTKEY_1, *this);



//*************** Navigation Form ******************************************

	__pNavigationForm  = new NavigationForm();
	__pNavigationForm-> Initialize(L"IDF_NAVIGATIONFORM");
	__pFrame->AddControl(*__pNavigationForm);

	__pNavigationForm->SetSoftkeyActionId(SOFTKEY_0, ID_NF_SOFTCART);
	__pNavigationForm->AddSoftkeyActionListener(SOFTKEY_0, *this);
	__pNavigationForm->SetSoftkeyActionId(SOFTKEY_1, ID_NF_SOFTNEXT);
	__pNavigationForm->AddSoftkeyActionListener(SOFTKEY_1, *this);

//**************Statistics Form ***********************************************
	__pStatisticsForm  = new Form();
	__pStatisticsForm-> Construct(L"IDF_STATISTICSFORM");
	__pFrame->AddControl(*__pStatisticsForm);

	__pSSDurationLabel = static_cast<Label *>(__pStatisticsForm->GetControl(L"IDC_SS_DURATION"));
	__pSSSpeedLabel= static_cast<Label *>(__pStatisticsForm->GetControl(L"IDC_SS_SPEED"));
	__pSSCalorieLabel = static_cast<Label *>(__pStatisticsForm->GetControl(L"IDC_SS_CALORIE"));

	__pStatisticsForm->SetSoftkeyActionId(SOFTKEY_1, ID_SS_MENU);
	__pStatisticsForm->AddSoftkeyActionListener(SOFTKEY_1, *this);
//**************Item Selector Form *********************************************

	__pItemSelectorForm  = new Form();
	__pItemSelectorForm-> Construct(L"IDF_ITEMSELECTOR");
	__pFrame->AddControl(*__pItemSelectorForm);

	__pItemSelectorList = static_cast<List *>(__pItemSelectorForm->GetControl(L"IDC_IS_LIST"));
	__pItemSelectorList->AddItemEventListener(*this);

	pButton = static_cast<Button *>(__pItemSelectorForm->GetControl(L"IDC_IS_CANCEL"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_SAVEFILE_BTNC);
		pButton->AddActionEventListener(*this);
	}
	pButton = static_cast<Button *>(__pItemSelectorForm->GetControl(L"IDC_IS_OK"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_IS_SELECT);
		pButton->AddActionEventListener(*this);
	}
//********************NEW ITEM POPUP*********************************************

	__pNewItemPopup = new Popup;
	__pNewItemPopup-> Construct(L"IDP_NEWITEM_POPUP");
	__pFrame->AddControl(*__pNewItemPopup);

	pButton = static_cast<Button *>(__pNewItemPopup->GetControl(L"IDC_NI_CANCEL"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_NI_POPUP_CANCEL);
		pButton->AddActionEventListener(*this);
	}
	pButton = static_cast<Button *>(__pNewItemPopup->GetControl(L"IDC_NI_OK"));
	if (pButton != null)
	{
		pButton->SetActionId(ID_NI_OK);
		pButton->AddActionEventListener(*this);
	}

	__pNewItemField = static_cast<EditField*>(__pNewItemPopup->GetControl(L"IDC_NI_EDIT"));

	SwitchToForm(__pMainForm);
	return true;
}

bool
ShopSmart::OnAppTerminating(AppRegistry& appRegistry, bool forcedTermination)
{
	// TODO:
	// Deallocate resources allocated by this application for termination.
	// The application's permanent data and context can be saved via appRegistry.

	return true;
}

void
ShopSmart::OnForeground(void)
{
	// TODO:
	// Start or resume drawing when the application is moved to the foreground.
}

void
ShopSmart::OnBackground(void)
{
	// TODO:
	// Stop drawing when the application is moved to the background.
}

void
ShopSmart::OnLowMemory(void)
{
	// TODO:
	// Free unused resources or close the application.
}

void
ShopSmart::OnBatteryLevelChanged(BatteryLevel batteryLevel)
{
	// TODO:
	// Handle any changes in battery level here.
	// Stop using multimedia features(camera, mp3 etc.) if the battery level is CRITICAL.
}

void
ShopSmart::OnScreenOn (void)
{
	// TODO:
	// Get the released resources or resume the operations that were paused or stopped in OnScreenOff().
}

void
ShopSmart::OnScreenOff (void)
{
	// TODO:
	//  Unless there is a strong reason to do otherwise, release resources (such as 3D, media, and sensors) to allow the device to enter the sleep mode to save the battery.
	// Invoking a lengthy asynchronous method within this listener method can be risky, because it is not guaranteed to invoke a callback before the device enters the sleep mode.
	// Similarly, do not perform lengthy operations in this listener method. Any operation must be a quick one.
}

void
ShopSmart::OnActionPerformed (const Osp::Ui::Control &source, int actionId)
{
	String title, message, filePath, label;
	AppResource *pAppResource = Application::GetInstance()->GetAppResource();
	MessageBox messageBox;
	int modalResult = 0;
	int i, last_position;
	Directory* pDir;
	DirEnumerator* pDirEnum;
	DateTime* timeSpanFormatter;
	int startinsecs, finishinsecs;

	switch (actionId)
	{
		case ID_MAINFORM_BTN1:
			FillShopList();

			SwitchToForm(__pFileSelectForm);
		break;
		case ID_MAINFORM_BTN2:
			dirName = L"/Home/Import";
			pDir = new Directory();
			pDir->Construct(dirName);
			pDirEnum = pDir->ReadN();
			if(!pDirEnum)
				AppLog("No such directory!");

			__pFileListItems->RemoveAll(true);
			__pFileList->RemoveAllItems();

			i = 0;

			// Loop through all directory entries
			while(pDirEnum->MoveNext() == E_SUCCESS)
			{
				DirEntry entry = pDirEnum->GetCurrentDirEntry();
				if(! entry.IsDirectory())
				{
					__pFileList->AddItem(new String(entry.GetName()), null, null, null, i);
					__pFileListItems->Add(*new Integer(i), *new String(entry.GetName()));
				}
				i++;
			}

			// Release Directory instance.
			// Opened directory is closed automatically when the destructor of the Directory class is invoked.
			delete pDir;
			pDir = null;
			delete pDirEnum;
			pDirEnum = null;

			SwitchToForm(__pFileSelectForm);
		break;
		case ID_MAINFORM_BTN3:
		break;
		case ID_MAINFORM_BTN4:
			if (pAppResource){
				pAppResource->GetString(L"IDS_MAINFORM_QUIT.title", title);
				pAppResource->GetString(L"IDS_MAINFORM_QUIT.text", message);
			}


			messageBox.Construct(title, message, MSGBOX_STYLE_YESNO, INFINITE);
			messageBox.ShowAndWait(modalResult);

			if(modalResult == MSGBOX_RESULT_YES)
				Terminate();
		break;
		case ID_FILESELECTFORM_BTN1:
			i = __pFileList->GetItemIdAt(__pFileList->GetFirstCheckedItemIndex());

			if(i>=0){
				if(dirName==L"/Home/Carts"){
					if(mode!='d'){
						filePath = dirName;
						filePath.Append(L"/");
						filePath.Append(*static_cast<String*>(__pFileListItems->GetValue((Integer)i)));

						File* fajl = new File;
						result r = fajl->Construct(filePath, L"r");
						if (r == E_FILE_NOT_FOUND){
							AppLog("%s\n", GetErrorMessage(r));
							break;
						}

						LinkedList* notInShop = new LinkedList;
						if(LoadCart(fajl, notInShop)!=E_SUCCESS){
							if (pAppResource){
								pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_ERROR.title", title);
								pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_ERROR.text", message);
							}

							messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
							messageBox.ShowAndWait(modalResult);
							break;
						} else {
							if (pAppResource && notInShop->GetCount()==0){
								pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_SUCCESS.title", title);
								pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_SUCCESS.text", message);
							} else if(pAppResource && notInShop->GetCount()>0){
								pAppResource->GetString(L"IDS_CARTLOAD_MISS.title", title);
								String msg;
								pAppResource->GetString(L"IDS_CARTLOAD_MISS.text", msg);

								IEnumerator* missenum = notInShop->GetEnumeratorN();
								missenum->Reset();
								missenum->MoveNext();
								message = *static_cast<String*>(missenum->GetCurrent());
								while(missenum->MoveNext()==E_SUCCESS){
									message.Append(L", ");
									message.Append(*static_cast<String*>(missenum->GetCurrent()));
								}
								delete missenum;
								message.Append(L" - ");
								message.Append(msg);
							}

							messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
							messageBox.ShowAndWait(modalResult);

						}

						delete notInShop;
						delete fajl;
						if (pAppResource){
							pAppResource->GetString(L"IDS_ITEMSELECTFORM_CARTLABEL", label);
						}
						String labeltext = Integer::ToString(Cart.GetCount());
						labeltext.Append(label);
						__pISFCartLabel->SetText(labeltext);
						__pISFCartLabel->RequestRedraw(true);

						SwitchToForm(__pItemSelectForm);
						break;
					} else if(mode=='d'){
						if (pAppResource){
							pAppResource->GetString(L"IDS_DELFORM.title", title);
							pAppResource->GetString(L"IDS_DELFORM_MSG", message);
						}

						messageBox.Construct(title, message, MSGBOX_STYLE_YESNO, INFINITE);
						messageBox.ShowAndWait(modalResult);
						if(modalResult==MSGBOX_RESULT_YES){
							filePath = dirName;
							filePath.Append(L"/");
							filePath.Append(*static_cast<String*>(__pFileListItems->GetValue((Integer)i)));
							File::Remove(filePath);
							SwitchToForm(__pItemSelectForm);
							if (pAppResource){
									pAppResource->GetString(L"IDS_FILESELECTFORM.title", title);
							}
							__pFileSelectForm->SetTitleText(title);
							mode = 'r';
							break;
						}
					}
				}
				else if(dirName==L"/Home/Import"){
					filePath = dirName;
					filePath.Append(L"/");
					filePath.Append(*static_cast<String*>(__pFileListItems->GetValue((Integer)i)));

					File* fajl = new File;
					result r = fajl->Construct(filePath, L"r");
					if (r == E_FILE_NOT_FOUND){
						AppLog("%s\n", GetErrorMessage(r));
						break;
					}

					if(__pShop){
						delete __pShop;
					}
					__pShop = new shop;
					r = __pShop->ParseFromFile(fajl);

					delete fajl;
					fajl = null;

					if(r!=E_SUCCESS){
						delete __pShop;
						__pShop = null;

						if (pAppResource){
							pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_ERROR.title", title);
							pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_ERROR.text", message);
						}

						messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
						messageBox.ShowAndWait(modalResult);
					} else {
						if (pAppResource){
							pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_SUCCESS.title", title);
							pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_SUCCESS.text", message);
						}

						messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
						messageBox.ShowAndWait(modalResult);

						FillShopSaveList();
						__pSaveFileEdit->SetText(L"");
						SwitchToForm(__pSaveForm);
					}
				} else if (dirName==L"/Home/Shops"){
				if(mode=='d'){
					if (pAppResource){
						pAppResource->GetString(L"IDS_DELFORM.title", title);
						pAppResource->GetString(L"IDS_DELFORM_MSG", message);
					}

					messageBox.Construct(title, message, MSGBOX_STYLE_YESNO, INFINITE);
					messageBox.ShowAndWait(modalResult);
					if(modalResult==MSGBOX_RESULT_YES){
						filePath = dirName;
						filePath.Append(L"/");
						filePath.Append(*static_cast<String*>(__pFileListItems->GetValue((Integer)i)));
						Directory::Remove(filePath,true);
						SwitchToForm(__pItemSelectForm);
						if (pAppResource){
								pAppResource->GetString(L"IDS_FILESELECTFORM.title", title);
						}
						__pFileSelectForm->SetTitleText(title);
						mode = 'r';
						break;
					}
				}
				if(mode!='d'){
					filePath = dirName;
					filePath.Append(L"/");
					filePath.Append(*static_cast<String*>(__pFileListItems->GetValue((Integer)i)));
					filePath.Append(L"/");
					filePath.Append(*static_cast<String*>(__pFileListItems->GetValue((Integer)i)));

					if(__pShop){
						delete __pShop;
					}
					__pShop = new shop;

					String filePathwithExtension;

					//Load shop infos

					filePathwithExtension = filePath;
					filePathwithExtension.Append(L".shp");

					File* fajl = new File;
					result r = fajl->Construct(filePathwithExtension, L"r");
					if(r==E_SUCCESS)
						r = __pShop->LoadInfoFromFile(fajl);
					delete fajl;

					//Load goods
					filePathwithExtension = filePath;
					filePathwithExtension.Append(L".god");

					fajl = new File;
					if(r==E_SUCCESS){
						r = fajl->Construct(filePathwithExtension, L"r");
						if(r==E_SUCCESS)
							r = __pShop->LoadItemsFromFile(fajl);
					}
					delete fajl;

					//Load nodes

					filePathwithExtension = filePath;
					filePathwithExtension.Append(L".nod");

					fajl = new File;
					if(r==E_SUCCESS){
						r = fajl->Construct(filePathwithExtension, L"r");
						if(r==E_SUCCESS)
							r = __pShop->LoadNodesFromFile(fajl);
					}
					delete fajl;

					//Load Checkouts

					filePathwithExtension = filePath;
					filePathwithExtension.Append(L".chk");

					fajl = new File;
					if(r==E_SUCCESS){
						r = fajl->Construct(filePathwithExtension, L"r");
						if(r==E_SUCCESS)
							r = __pShop->LoadCheckoutsFromFile(fajl);
					}
					delete fajl;

					//Load Architecture

					filePathwithExtension = filePath;
					filePathwithExtension.Append(L".arc");

					fajl = new File;
					if(r==E_SUCCESS){
						r = fajl->Construct(filePathwithExtension, L"r");
						if(r==E_SUCCESS)
							r = __pShop->LoadArchitectureFromFile(fajl);
					}
					delete fajl;
					fajl = null;

					if(r!=E_SUCCESS){
						delete __pShop;
						__pShop = null;

						if (pAppResource){
							pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_ERROR.title", title);
							pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_ERROR.text", message);
						}

						messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
						messageBox.ShowAndWait(modalResult);
					} else {
						if (pAppResource){
							pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_SUCCESS.title", title);
							pAppResource->GetString(L"IDS_FILESELECTFORM_PARSE_SUCCESS.text", message);
						}

						messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
						messageBox.ShowAndWait(modalResult);


						__pISFLabel->SetText(__pShop->Name);
						Cart.RemoveAll(true);
						__pItemSelectList->RemoveAllItems();
						__pItemSelectorList->RemoveAllItems();
						FillItemSelectList();

						if (pAppResource){
							pAppResource->GetString(L"IDS_ITEMSELECTFORM_CARTLABEL", label);
						}
						String labeltext = Integer::ToString(Cart.GetCount());
						labeltext.Append(label);
						__pISFCartLabel->SetText(labeltext);
						__pISFCartLabel->RequestRedraw(true);

						SwitchToForm(__pItemSelectForm);
					}

				}
				}

			}
		break;
		case ID_FILESELECTFORM_BTN2:
			mode = 'r';
			if (pAppResource){
					pAppResource->GetString(L"IDS_FILESELECTFORM.title", title);
			}
			__pFileSelectForm->SetTitleText(title);
			if(dirName==L"/Home/Import" || dirName==L"/Home/Shops"){
				SwitchToForm(__pMainForm);
			} else {
				SwitchToForm(__pItemSelectForm);
			}
		break;
		case ID_SAVEFILE_BTNOK:
			label = __pSaveFileEdit->GetText();
			label.Trim();
			if(label==L""){
				break;
			}
			if(dirName == L"/Home/Carts"){
				String fileName = dirName;
				fileName.Append(L"/");
				fileName.Append(label);
				fileName.Append(L".lis");
				File* fajl = new File;
				result r = fajl->Construct(fileName,L"w",false);

				r = SaveCart(fajl);
				delete fajl;

				if (r==E_SUCCESS){
					if (pAppResource){
						pAppResource->GetString(L"IDS_SAVEFORM_SUCCESS.title", title);
						pAppResource->GetString(L"IDS_SAVEFORM_SUCCESS.text", message);
					}

					messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
					messageBox.ShowAndWait(modalResult);

					SwitchToForm(__pItemSelectForm);
				} else {
					if (pAppResource){
						pAppResource->GetString(L"IDS_SAVEFORM_ERROR.title", title);
						pAppResource->GetString(L"IDS_SAVEFORM_ERROR.text", message);
					}

					messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
					messageBox.ShowAndWait(modalResult);
				}

			}
			if(dirName == L"/Home/Shops"){
				dirName = L"/Home/Shops/";
				dirName.Append(label);
				pDir = new Directory;
				result r = pDir->Construct(dirName);
				if(r == E_FILE_NOT_FOUND){
					pDir->Create(dirName);
				} else if(r == E_SUCCESS){
					if (pAppResource){
						pAppResource->GetString(L"IDS_SAVEFORM_OVERWRITE.title", title);
						pAppResource->GetString(L"IDS_SAVEFORM_OVERWRITE.text", message);
					}
					messageBox.Construct(title, message, MSGBOX_STYLE_YESNO, INFINITE);
					messageBox.ShowAndWait(modalResult);

					if (modalResult == MSGBOX_RESULT_NO){
						delete pDir;
						dirName = L"/Home/Shops";
						break;
					}
				}

				delete pDir;

				String fileName = dirName;
				fileName.Append(L"/");
				fileName.Append(label);

				//Save the shop infos

				String fileNamewithExtension = fileName;
				fileNamewithExtension.Append(L".shp");
				File* fajl = new File;
				fajl->Construct(fileNamewithExtension,L"w",false);
				r = __pShop->SaveInfoToFile(fajl);
				delete fajl;

				//Save the goods

				if (r==E_SUCCESS){
					fileNamewithExtension = fileName;
					fileNamewithExtension.Append(L".god");
					fajl = new File;
					fajl->Construct(fileNamewithExtension,L"w",false);
					r = __pShop->SaveItemsToFile(fajl);
					delete fajl;
				}

				//Save the nodes

				if (r==E_SUCCESS){
					fileNamewithExtension = fileName;
					fileNamewithExtension.Append(L".nod");
					fajl = new File;
					fajl->Construct(fileNamewithExtension,L"w",false);
					r = __pShop->SaveNodesToFile(fajl);
					delete fajl;
				}

				//Save the checkouts

				if (r==E_SUCCESS){
					fileNamewithExtension = fileName;
					fileNamewithExtension.Append(L".chk");
					fajl = new File;
					fajl->Construct(fileNamewithExtension,L"w",false);
					r = __pShop->SaveCheckoutsToFile(fajl);
					delete fajl;
				}

				//Save the architecture

				if (r==E_SUCCESS){
					fileNamewithExtension = fileName;
					fileNamewithExtension.Append(L".arc");
					fajl = new File;
					fajl->Construct(fileNamewithExtension,L"w",false);
					r = __pShop->SaveArchitectureToFile(fajl);
					delete fajl;
				}

				if (r==E_SUCCESS){
					if (pAppResource){
						pAppResource->GetString(L"IDS_SAVEFORM_SUCCESS.title", title);
						pAppResource->GetString(L"IDS_SAVEFORM_SUCCESS.text", message);
					}

					messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
					messageBox.ShowAndWait(modalResult);

					Cart.RemoveAll(true);
					__pItemSelectList->RemoveAllItems();
					__pItemSelectorList->RemoveAllItems();
					FillItemSelectList();
					SwitchToForm(__pItemSelectForm);
				} else {
					if (pAppResource){
						pAppResource->GetString(L"IDS_SAVEFORM_ERROR.title", title);
						pAppResource->GetString(L"IDS_SAVEFORM_ERROR.text", message);
					}

					messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
					messageBox.ShowAndWait(modalResult);
				}
			}
		break;
		case ID_SAVEFILE_BTNC:
			if(dirName==L"/Home/Shops"){
			Cart.RemoveAll(true);
			__pItemSelectList->RemoveAllItems();
			__pItemSelectorList->RemoveAllItems();
			FillItemSelectList();
			}
			SwitchToForm(__pItemSelectForm);

		break;

		case ID_ISF_BTEL:
			Cart.RemoveAll(true);
			__pItemSelectList->SetAllItemsChecked(false);
			__pItemSelectList->RequestRedraw(true);
			if (pAppResource){
				pAppResource->GetString(L"IDS_ITEMSELECTFORM_CARTLABEL", title);
			}
			message = Integer::ToString(Cart.GetCount());
			message.Append(title);
			__pISFCartLabel->SetText(message);
			__pISFCartLabel->RequestRedraw(true);
		break;

		case ID_ISF_OPT:
			__pISFOptionMenu->SetShowState(true);
			__pISFOptionMenu->Show();
		break;

		case ID_ISF_SOFTPLAN:
			if(Cart.GetCount()==0){
				if (pAppResource){
					pAppResource->GetString(L"IDS_ITEMSELECTFORM_ERROR.title", title);
					pAppResource->GetString(L"IDS_ITEMSELECTFORM_ERROR.text", message);
				}

				messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
				messageBox.ShowAndWait(modalResult);
				break;
			}

			if(__pShop->Navigation){
				delete __pShop->Navigation;
				__pShop->Navigation = null;
			}

			__pShop->Navigation = new Route(__pShop->Nodes, __pShop->Goods, __pShop->Checkouts, __pShop->Architecture);
			__pShop->Navigation->Cart->RemoveAll();
			__pShop->Navigation->Cart->AddItems(Cart);
			__pShop->Navigation->PlanRoute();

			__pShop->Navigation->CalculateTotalDistance();
			__pShop->Navigation->CalculateTimeLeft();

			__pCFShopLabel->SetText(__pShop->Name);
			__pCFAddressLabel->SetText(__pShop->Address);

			label.Clear();
			label.Format(15, L"%f m", __pShop->Navigation->TotalDistance->ToDouble());

			__pCFDistanceLabel->SetText(label);
			label.Clear();
			timeSpanFormatter = new DateTime();
			timeSpanFormatter->SetValue(2011,1,1,__pShop->Navigation->TimeLeft->GetHours(),__pShop->Navigation->TimeLeft->GetMinutes(),__pShop->Navigation->TimeLeft->GetSeconds());
			timeSpanFormatter->ToString().SubString(11, label);
			delete timeSpanFormatter;

			__pCFDurationLabel->SetText(label);

			label.Clear();
			__pShop->Navigation->CheckoutTime->ToString().SubString(11, label);
			//label.Format(10, L"%d:%d:%d", __pShop->Navigation->CheckoutTime->GetHour(), __pShop->Navigation->CheckoutTime->GetMinute(), __pShop->Navigation->CheckoutTime->GetSecond());
			__pCFArrivalLabel->SetText(label);


			SwitchToForm(__pCalculatedForm);
		break;
		case ID_CF_SOFTCART:
			SwitchToForm(__pItemSelectForm);
		break;
		case ID_CF_SOFTSTART:
			__pNavigationForm->ReloadData(__pShop);
			if (pAppResource){
				pAppResource->GetString(L"IDS_NF_SOFTNEXT", title);
			}
			__pNavigationForm->SetSoftkeyText(SOFTKEY_1, title);
			__pShop->Navigation->NavigationStart = new DateTime;
			Osp::System::SystemTime::SystemTime::GetCurrentTime(Osp::System::WALL_TIME, *__pShop->Navigation->NavigationStart);
			SwitchToForm(__pNavigationForm);
		break;
		case ID_ISF_SOFTMENU:
			Cart.RemoveAll(true);
			__pItemSelectList->RemoveAllItems();
			SwitchToForm(__pMainForm);
		break;
		case ID_ISF_OPT_SAVE_SHOP:

			FillShopSaveList();
			__pSaveFileEdit->SetText(L"");
			SwitchToForm(__pSaveForm);
		break;
		case ID_NF_SOFTNEXT:

			if(__pNavigationForm->position_index==__pShop->Navigation->OptimalOrder->GetCount()-2){
				//End of navigation
				__pShop->Navigation->NavigationFinish = new DateTime;
				Osp::System::SystemTime::SystemTime::GetCurrentTime(Osp::System::WALL_TIME, *__pShop->Navigation->NavigationFinish);
				startinsecs = __pShop->Navigation->NavigationStart->GetHour()*3600 + __pShop->Navigation->NavigationStart->GetMinute()*60 + __pShop->Navigation->NavigationStart->GetSecond();
				finishinsecs = __pShop->Navigation->NavigationFinish->GetHour()*3600 + __pShop->Navigation->NavigationFinish->GetMinute()*60 + __pShop->Navigation->NavigationFinish->GetSecond();
				timeSpanFormatter = new DateTime();
				timeSpanFormatter->SetValue(2011,1,1,0,0,0);
				timeSpanFormatter->AddSeconds(finishinsecs-startinsecs);
				timeSpanFormatter->ToString().SubString(11, label);
				__pSSDurationLabel->SetText(label);
				__pSSDurationLabel->RequestRedraw(true);

				i = timeSpanFormatter->GetHour()*3600 + timeSpanFormatter->GetMinute()*60 + timeSpanFormatter->GetSecond();
				label.Format(20,L"%f km/h", __pShop->Navigation->TotalDistance->ToDouble()/i*3.6);
				__pSSSpeedLabel->SetText(label);
				__pSSSpeedLabel->RequestRedraw(true);

				label.Format(20, L"%f cal", i*0.045);
				__pSSCalorieLabel->SetText(label);
				__pSSCalorieLabel->RequestRedraw(true);

				delete timeSpanFormatter;
				SwitchToForm(__pStatisticsForm);
			} else {
				//Jump to next station
				__pNavigationForm->DrawNextData();

			}
		break;
		case ID_NF_SOFTCART:
			last_position = __pNavigationForm->position_index;

			if (pAppResource){
				pAppResource->GetString(L"IDS_NF_MESSAGE_BACK.title", title);
				pAppResource->GetString(L"IDS_NF_MESSAGE_BACK.text", message);
			}
			messageBox.Construct(title, message, MSGBOX_STYLE_YESNO, INFINITE);
			messageBox.ShowAndWait(modalResult);

			if (modalResult == MSGBOX_RESULT_YES){
				SwitchToForm(__pItemSelectForm);
				break;
			} else {
				__pShop->Navigation->CalculateTotalDistance();
				__pShop->Navigation->CalculateTimeLeft();
				for (int i = 1; i <= last_position; i++){
					__pNavigationForm->DrawNextData();
				}
			}
		break;
		case ID_SS_MENU:
			if (pAppResource){
				pAppResource->GetString(L"IDS_SS_SAVELIST.title", title);
				pAppResource->GetString(L"IDS_SS_SAVELIST.text", message);
			}
			messageBox.Construct(title, message, MSGBOX_STYLE_YESNO, INFINITE);
			messageBox.ShowAndWait(modalResult);

			if(modalResult==MSGBOX_RESULT_NO){
				delete __pShop->Navigation;
				SwitchToForm(__pMainForm);
			} else {
				FillCartSaveList();
				__pSaveFileEdit->SetText(L"");
				SwitchToForm(__pSaveForm);
			}
		break;
		case ID_ISF_OPT_DELETE_SHOP:
			FillShopList();
			mode = 'd';
			if (pAppResource){
					pAppResource->GetString(L"IDS_DELFORM.title", title);
			}
			__pFileSelectForm->SetTitleText(title);

			SwitchToForm(__pFileSelectForm);

		break;
		case ID_ISF_OPT_DELETE_CART:
			FillCartList();
			mode = 'd';
			if (pAppResource){
					pAppResource->GetString(L"IDS_DELFORM.title", title);
			}
			__pFileSelectForm->SetTitleText(title);

			SwitchToForm(__pFileSelectForm);
		break;
		case ID_ISF_OPT_LOAD_CART:
			FillCartList();
			SwitchToForm(__pFileSelectForm);
		break;
		case ID_ISF_OPT_SAVE_CART:
			if(Cart.GetCount()==0){
				if (pAppResource){
					pAppResource->GetString(L"IDS_ITEMSELECTFORM_ERROR.title", title);
					pAppResource->GetString(L"IDS_ITEMSELECTFORM_ERROR.text", message);
				}

				messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
				messageBox.ShowAndWait(modalResult);
				break;
			}

			FillCartSaveList();
			__pSaveFileEdit->SetText(L"");
			SwitchToForm(__pSaveForm);
		break;
		case ID_ISF_OPT_MOVE_ITEM:
			MoveWhat.Clear();
			MoveWhere.Clear();
			if (pAppResource){
				pAppResource->GetString(L"IDS_IS_CHOOSEITEM", title);
			}
			__pItemSelectorForm->SetTitleText(title);

			SelectedItem.Clear();

			__pItemSelectorList->SetAllItemsChecked(false);
			__pItemSelectorList->RequestRedraw();
			mode = 'm';
			SwitchToForm(__pItemSelectorForm);
		break;
		case ID_ISF_OPT_DELETE_ITEM:
			if (pAppResource){
				pAppResource->GetString(L"IDS_IS_CHOOSEITEM", title);
			}
			__pItemSelectorForm->SetTitleText(title);

			SelectedItem.Clear();

			__pItemSelectorList->SetAllItemsChecked(false);
			__pItemSelectorList->RequestRedraw();
			mode = 'd';
			SwitchToForm(__pItemSelectorForm);
		break;
		case ID_ISF_OPT_NEW_ITEM:
			__pNewItemField->Clear();
			__pNewItemPopup->SetShowState(true);
			__pNewItemPopup->Show();
		break;
		case ID_NI_OK:
			label = __pNewItemField->GetText();
			label.Trim();
			if(label!=L""){
				if (pAppResource){
					pAppResource->GetString(L"IDS_IS_CHOOSEPLACE", title);
				}
				__pItemSelectorForm->SetTitleText(title);
				SelectedItem.Clear();
				__pItemSelectorList->SetAllItemsChecked(false);
				__pItemSelectorList->RequestRedraw(true);
				__pItemSelectorForm->RequestRedraw(true);

				itemName = label;
				mode = 'c';

				__pNewItemPopup->SetShowState(false);
				__pNewItemPopup->RequestRedraw(false);
				SwitchToForm(__pItemSelectorForm);
			}
		break;
		case ID_IS_SELECT:
			if(!SelectedItem.IsEmpty() && mode=='m'){
				if(MoveWhat.IsEmpty()){
					MoveWhat = SelectedItem;

					if (pAppResource){
						pAppResource->GetString(L"IDS_IS_CHOOSEPLACE", title);
					}
					__pItemSelectorForm->SetTitleText(title);

					SelectedItem.Clear();
					__pItemSelectorList->SetAllItemsChecked(false);
					__pItemSelectorList->RequestRedraw(true);
					__pItemSelectorForm->RequestRedraw(true);
				} else {
					MoveWhere = SelectedItem;
					if(__pShop->MoveItem(MoveWhat,MoveWhere)==E_SUCCESS){
						if (pAppResource){
							pAppResource->GetString(L"IDS_ISF_MOVE_ITEM.text", title);
							pAppResource->GetString(L"IDS_IS_MOVED", message);
						}

						messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
						messageBox.ShowAndWait(modalResult);
					} else {
						if (pAppResource){
							pAppResource->GetString(L"IDS_SAVEFORM_ERROR.title", title);
							pAppResource->GetString(L"IDS_IS_ERROR", message);
						}

						messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
						messageBox.ShowAndWait(modalResult);
					}
					mode = 'r';
					SwitchToForm(__pItemSelectForm);
				}
			} else if(!SelectedItem.IsEmpty() && mode=='d'){
				if(__pShop->DeleteItem(SelectedItem)==E_SUCCESS){
					if (pAppResource){
						pAppResource->GetString(L"IDS_ISF_DELETE_ITEM.text", title);
						pAppResource->GetString(L"IDS_IS_DELETED", message);
					}

					messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
					messageBox.ShowAndWait(modalResult);
				} else {
					if (pAppResource){
						pAppResource->GetString(L"IDS_SAVEFORM_ERROR.title", title);
						pAppResource->GetString(L"IDS_IS_ERROR", message);
					}

					messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
					messageBox.ShowAndWait(modalResult);
				}
				mode = 'r';
				Cart.RemoveAll(true);
				__pItemSelectList->RemoveAllItems();
				__pItemSelectorList->RemoveAllItems();
				FillItemSelectList();

				if (pAppResource){
					pAppResource->GetString(L"IDS_ITEMSELECTFORM_CARTLABEL", label);
				}
				String labeltext = Integer::ToString(Cart.GetCount());
				labeltext.Append(label);
				__pISFCartLabel->SetText(labeltext);
				__pISFCartLabel->RequestRedraw(true);
				SwitchToForm(__pItemSelectForm);
			} else if(!SelectedItem.IsEmpty() && mode=='c'){
				if(__pShop->NewItem(itemName,SelectedItem)==E_SUCCESS){
				if (pAppResource){
					pAppResource->GetString(L"IDS_ISF_NEW_ITEM.text", title);
					pAppResource->GetString(L"IDS_IS_CREATE", message);
				}

				messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
				messageBox.ShowAndWait(modalResult);
			} else {
				if (pAppResource){
					pAppResource->GetString(L"IDS_SAVEFORM_ERROR.title", title);
					pAppResource->GetString(L"IDS_IS_ERROR", message);
				}

				messageBox.Construct(title, message, MSGBOX_STYLE_OK, INFINITE);
				messageBox.ShowAndWait(modalResult);
			}
			mode = 'r';
			Cart.RemoveAll(true);
			__pItemSelectList->RemoveAllItems();
			__pItemSelectorList->RemoveAllItems();
			FillItemSelectList();

			if (pAppResource){
				pAppResource->GetString(L"IDS_ITEMSELECTFORM_CARTLABEL", label);
			}
			String labeltext = Integer::ToString(Cart.GetCount());
			labeltext.Append(label);
			__pISFCartLabel->SetText(labeltext);
			__pISFCartLabel->RequestRedraw(true);
			SwitchToForm(__pItemSelectForm);
			}
		break;
		case ID_NI_POPUP_CANCEL:
			__pNewItemPopup->SetShowState(false);
			__pNewItemPopup->RequestRedraw(false);
			__pItemSelectForm->RequestRedraw(true);
		break;
		default:
			AppLog("Action ID: %d", actionId);
		break;
	}
}

void  ShopSmart::OnItemStateChanged(const Osp::Ui::Control &source, int index, int itemId, Osp::Ui::ItemStatus status)
{
	if(source.Equals(*__pSaveFileList)){
		if(dirName==L"/Home/Carts"){
			String name, listname;
			listname = *static_cast<String*>(__pFileListItems->GetValue((Integer)itemId));
			listname.SubString(0,listname.GetLength()-4,name);

			__pSaveFileEdit->SetText(name);
		} else {
			__pSaveFileEdit->SetText(*static_cast<String*>(__pFileListItems->GetValue((Integer)itemId)));
		}
		__pSaveFileEdit->RequestRedraw(true);
	}
	if(source.Equals(*__pItemSelectList)){
		AppResource *pAppResource = Application::GetInstance()->GetAppResource();
		String label;
		if (status==ITEM_CHECKED)
			Cart.Add(*new String(*static_cast<String*>(__pSelectItemsListItems->GetValue(Integer(itemId)))));
		if (status==ITEM_UNCHECKED)
			Cart.Remove(*static_cast<String*>(__pSelectItemsListItems->GetValue(Integer(itemId))),true);
		if (pAppResource){
			pAppResource->GetString(L"IDS_ITEMSELECTFORM_CARTLABEL", label);
		}
		String labeltext = Integer::ToString(Cart.GetCount());
		labeltext.Append(label);
		__pISFCartLabel->SetText(labeltext);
		__pISFCartLabel->RequestRedraw(true);
	}
	if(source.Equals(*__pItemSelectorList)){
		SelectedItem = *static_cast<String*>(__pSelectItemsListItems->GetValue(Integer(itemId)));
	}

}

void ShopSmart::FillCartList(void)
{
	dirName = L"/Home/Carts";
	Directory* pDir = new Directory();
	pDir->Construct(dirName);
	DirEnumerator* pDirEnum = pDir->ReadN();
	if(!pDirEnum)
		AppLog("No such directory!");

	__pFileListItems->RemoveAll(true);
	__pFileList->RemoveAllItems();

	int i = 0;

	// Loop through all directory entries
	while(pDirEnum->MoveNext() == E_SUCCESS)
	{
		DirEntry entry = pDirEnum->GetCurrentDirEntry();
		if(! entry.IsDirectory())
		{
			__pFileList->AddItem(new String(entry.GetName()), null, null, null, i);
			__pFileListItems->Add(*new Integer(i), *new String(entry.GetName()));
		}
		i++;
	}

	// Release Directory instance.
	// Opened directory is closed automatically when the destructor of the Directory class is invoked.
	delete pDir;
	pDir = null;
	delete pDirEnum;
	pDirEnum = null;

}

void ShopSmart::FillShopList(void)
{
	dirName = L"/Home/Shops";
	Directory* pDir;
	DirEnumerator* pDirEnum;
	pDir = new Directory();
	pDir->Construct(dirName);
	pDirEnum = pDir->ReadN();
	if(!pDirEnum)
		AppLog("No such directory!");

	__pFileListItems->RemoveAll(true);
	__pFileList->RemoveAllItems();

	pDirEnum->Reset();
	pDirEnum->MoveNext();
	pDirEnum->MoveNext();

	int i = 0;

	// Loop through all directory entries
	while(pDirEnum->MoveNext() == E_SUCCESS)
	{
		DirEntry entry = pDirEnum->GetCurrentDirEntry();
		if(entry.IsDirectory())
		{
			__pFileList->AddItem(new String(entry.GetName()), null, null, null, i);
			__pFileListItems->Add(*new Integer(i), *new String(entry.GetName()));
		}
		i++;
	}

	// Release Directory instance.
	// Opened directory is closed automatically when the destructor of the Directory class is invoked.
	delete pDir;
	pDir = null;
	delete pDirEnum;
	pDirEnum = null;
}

void ShopSmart::FillCartSaveList(void){
	dirName = L"/Home/Carts";
	Directory* pDir;
	DirEnumerator* pDirEnum;
	pDir = new Directory();
	pDir->Construct(dirName);
	pDirEnum = pDir->ReadN();
	if(!pDirEnum)
		AppLog("No such directory!");

	__pFileListItems->RemoveAll(true);
	__pSaveFileList->RemoveAllItems();

	pDirEnum->Reset();

	int i = 0;

	// Loop through all file entries
	while(pDirEnum->MoveNext() == E_SUCCESS)
	{
		DirEntry entry = pDirEnum->GetCurrentDirEntry();
		if(!entry.IsDirectory())
		{
			__pSaveFileList->AddItem(new String(entry.GetName()), null, null, null, i);
			__pFileListItems->Add(*new Integer(i), *new String(entry.GetName()));
		}
		i++;
	}

	// Release Directory instance.
	// Opened directory is closed automatically when the destructor of the Directory class is invoked.
	delete pDir;
	pDir = null;
	delete pDirEnum;
	pDirEnum = null;
}

void ShopSmart::FillShopSaveList(void)
{
	dirName = L"/Home/Shops";
	Directory* pDir;
	DirEnumerator* pDirEnum;
	pDir = new Directory();
	pDir->Construct(dirName);
	pDirEnum = pDir->ReadN();
	if(!pDirEnum)
		AppLog("No such directory!");

	__pFileListItems->RemoveAll(true);
	__pSaveFileList->RemoveAllItems();

	pDirEnum->Reset();
	pDirEnum->MoveNext();
	pDirEnum->MoveNext();

	int i = 0;

	// Loop through all directory entries
	while(pDirEnum->MoveNext() == E_SUCCESS)
	{
		DirEntry entry = pDirEnum->GetCurrentDirEntry();
		if(entry.IsDirectory())
		{
			__pSaveFileList->AddItem(new String(entry.GetName()), null, null, null, i);
			__pFileListItems->Add(*new Integer(i), *new String(entry.GetName()));
		}
		i++;
	}

	// Release Directory instance.
	// Opened directory is closed automatically when the destructor of the Directory class is invoked.
	delete pDir;
	pDir = null;
	delete pDirEnum;
	pDirEnum = null;
}

void ShopSmart::FillItemSelectList(void){
	ArrayList* itemsAlphabetically = static_cast <ArrayList*> ( __pShop->Goods->GetKeysN());
	HUNStringComparer HUNcomparer;
	itemsAlphabetically->Sort(HUNcomparer);
	IEnumerator* enumalpha = itemsAlphabetically->GetEnumeratorN();
	enumalpha->Reset();
	__pSelectItemsListItems->RemoveAll(true);

	int i = 0;

	while(enumalpha->MoveNext()==E_SUCCESS){
		String* item = static_cast<String*>(enumalpha->GetCurrent());
		__pSelectItemsListItems->Add(*new Integer(i),*new String(*item));

		// Add the item to the list

		__pItemSelectList->AddItem(item, null, null, null, i);
		__pItemSelectorList->AddItem(item, null, null, null, i);
		i++;
	}

	delete enumalpha;

	delete itemsAlphabetically;
}

result ShopSmart::SaveCart(File* Fajl){
	result r = E_SUCCESS;
	r = Fajl->Write(L"CART\r\n");

	IEnumerator* cartnum = Cart.GetEnumeratorN();
	cartnum->Reset();
	if (r ==E_SUCCESS)
	{
		r = Fajl->Write(Integer::ToString(Cart.GetCount()));
		r = Fajl->Write(L"\r\n");
	}
	while(cartnum->MoveNext()==E_SUCCESS && r == E_SUCCESS){
		if(r==E_SUCCESS)
		Fajl->Write(*static_cast<String*>(cartnum->GetCurrent()));
		if(r==E_SUCCESS)
		Fajl->Write(L"\r\n");
	}
	delete cartnum;

	return r;
}

result ShopSmart::LoadCart(File* Fajl, LinkedList* NotInShopListN){
	result r = E_SUCCESS;
	Cart.RemoveAll(true);
	__pItemSelectList->SetAllItemsChecked(false);

	String sor;
	r = Fajl->Read(sor);

	if (r!=E_SUCCESS){
		return r;
	}

	__pShop->PExpectFromFile(Fajl, sor, false, L"", L"\n\r");

	int count;
	r = Integer::Parse(sor, count);
	if (r!=E_SUCCESS){
			return r;
	}

	IMapEnumerator* listenum = __pSelectItemsListItems->GetMapEnumeratorN();

	for(int i=1;i<=count;i++){
		__pShop->PExpectFromFile(Fajl, sor, false, L"", L"\n\r");
		bool contains = false;
		__pShop->Goods->ContainsKey(sor, contains);
		if(contains){
			Cart.Add(*new String(sor));

			listenum->Reset();
			listenum->MoveNext();
			while(sor!= *static_cast<String*>(listenum->GetValue())){
				listenum->MoveNext();
			}

			r = __pItemSelectList->SetItemChecked(static_cast<Integer*>(listenum->GetKey())->ToInt(),true);

		} else{
			NotInShopListN->Add(*new String(sor));
		}
	}

	delete listenum;

	return r;
}


result
ShopSmart::SwitchToForm(Form* pNextForm)
{
	result r = E_SUCCESS;

	// TODO: do something closing entry with __pCURRP
	__pNEXTF = pNextForm;
	if(__pCURRF)
	{
		r = __pCURRF->SetShowState(false);
			if(IsFailed(r)) goto CATCH;
		__pCURRF->RequestRedraw(true);
	}

	if(__pNEXTF)
	{
		__pFrame->SetCurrentForm(*__pNEXTF);
		r = __pNEXTF->SetShowState(true);
		if(IsFailed(r)) goto CATCH;
		__pNEXTF->RequestRedraw(true);
		__pCURRF = __pNEXTF;
	}
	return r;

CATCH:
	AppLog("SwitchToForm failed: %s", GetErrorMessage(r));
	return r;
}

