/*
 * shop.cpp
 *
 *  Created on: 2011.03.23.
 *      Author: Imi
 */

#include "shop.h"

shop::shop() {
	// TODO Auto-generated constructor stub
	//Construct Base
	Name.Clear();
	Address.Clear();

	Base = new Osp::Graphics::Rectangle(0,0,0,0);


	//Construct Goods list
	Goods = new HashMap;
	Goods->Construct();

	Nodes = new HashMap;
	Nodes->Construct();

	Checkouts = new LinkedList;

	Architecture = new HashMap;
	Architecture->Construct();

	Navigation = null;

	ImportLineNumber = 0;

}

shop::~shop() {
	// TODO Auto-generated destructor stub
	delete Base;
	Goods->RemoveAll(true);
	delete Goods;
	Nodes->RemoveAll(true);
	delete Nodes;
	Checkouts->RemoveAll(true);
	delete Checkouts;
	/*IMapEnumerator* arcenum = Architecture->GetMapEnumeratorN();
	arcenum->Reset();
	while(arcenum->MoveNext()==E_SUCCESS){
		static_cast<HashMap*>(arcenum->GetValue())->RemoveAll(true);
	}
	delete arcenum;*/
	Architecture->RemoveAll(true);
	delete Architecture;


}

result shop::ParseFromFile(File* Fajl) {
	Goods->RemoveAll(true);
	Nodes->RemoveAll(true);
	Architecture->RemoveAll(true);
	Name.Clear();
	Address.Clear();

	result r = E_SUCCESS;

	String sor;
	String read;

	r = Fajl->Read(sor);//Reading of useless first row, containing UTF-8 infos
	ImportLineNumber++;
	if (r!=E_SUCCESS){
		AppLog("***%d: Cannot read from file!",ImportLineNumber);
		return r;
	} else {
		AppLog("VERSION INFORMATION %S", sor.GetPointer());
	}

	if (PExpectFromFile(Fajl, read, true, L"NAME")==false){
		AppLog("***%d: Invalid header!",ImportLineNumber);
		return E_INVALID_HEADER;
	} else {
		AppLog("%S token found", read.GetPointer());
	}

	if (PExpectFromFile(Fajl, read, false, L"", L"\n\r\t\f")==false){
		AppLog("***%d: Invalid name!",ImportLineNumber);
		return E_INVALID_DATA;
	} else {
		Name = read;
		AppLog("Name = %S", read.GetPointer());
	}

	if (PExpectFromFile(Fajl, read, true, L"ADDRESS")==false){
			AppLog("***%d: Invalid header!",ImportLineNumber);
			return E_INVALID_HEADER;
		} else {
			AppLog("%S token found", read.GetPointer());
		}

	if (PExpectFromFile(Fajl, read, false, L"", L"\n\r\t\f")==false){
			AppLog("***%d: Invalid name!",ImportLineNumber);
			return E_INVALID_DATA;
		} else {
			Address = read;
			AppLog("Address = %S", read.GetPointer());
		}

	if (PExpectFromFile(Fajl, read, true, L"BASE")==false){
				AppLog("***%d: Invalid header!",ImportLineNumber);
				return E_INVALID_HEADER;
		} else {
				AppLog("%S token found", read.GetPointer());
		}
	//Read Base coordinates
	r = Fajl->Read(sor);
	ImportLineNumber++;
		if (r!=E_SUCCESS){
			AppLog("*** %d: CorridorParser: Cannot read from file!",ImportLineNumber);
			return E_INVALID_FORMAT;
	}
	//Parse coordinates
	StringTokenizer coordinateTokenizer(sor, L" ,\n\r\t\f");
		if (coordinateTokenizer.GetTokenCount()!=2){// int count != 2
				AppLog("*** %d: 2 ints need for a Base dimension!", ImportLineNumber);
				return E_INVALID_FORMAT;
		}

	String xstr, ystr;
	coordinateTokenizer.GetNextToken(xstr);
	coordinateTokenizer.GetNextToken(ystr);

	int x, y;

		if (Integer::Parse(xstr, x)!=E_SUCCESS || Integer::Parse(ystr, y)!=E_SUCCESS){//Check int validity
			AppLog("*** %d: %S or %S not a valid int!", ImportLineNumber,xstr.GetPointer(), ystr.GetPointer());
			return E_INVALID_DATA;
		}

	Base->SetBounds(0,0,x,y);
	AppLog("Base set to (0,0)(%d,%d)", x,y);


	if (PExpectFromFile(Fajl, read, true, L"ENTRANCE")==false){
			AppLog("***%d: Invalid header!",ImportLineNumber);
			return E_INVALID_HEADER;
		} else {
			AppLog("%S token found", read.GetPointer());
		}
	//Read entrance coordinates
		r = Fajl->Read(sor);
		ImportLineNumber++;
			if (r!=E_SUCCESS){
				AppLog("*** %d: FileParser: Cannot read from file!",ImportLineNumber);
				return E_INVALID_FORMAT;
		}

	//Parse coordinates of entrance point
		StringTokenizer entranceTokenizer(sor, L" ,\n\r\t\f");
		if (entranceTokenizer.GetTokenCount()!=2){// int count != 2
				AppLog("*** %d: FileParser: 2 ints need for a coordinate!",ImportLineNumber);
				return E_INVALID_FORMAT;
		}

		String x1str, y1str;

		entranceTokenizer.GetNextToken(x1str);
		entranceTokenizer.GetNextToken(y1str);
	int x1, y1;
	if (Integer::Parse(x1str, x1)!=E_SUCCESS || Integer::Parse(y1str, y1)!=E_SUCCESS){//Check int validity
			AppLog("*** %d: FileParser: %S or %S not a valid int!",ImportLineNumber, x1str.GetPointer(), y1str.GetPointer());
			return E_INVALID_DATA;
		}
	Osp::Graphics::Point* pont = new Osp::Graphics::Point(x1,y1);
	if (Base->Contains(*pont)==false){//Point in base check
			AppLog("*** %d: FIleParser: (%d,%d) coordinate out of Base!",ImportLineNumber, x1, y1);
			return E_INVALID_DATA;
		}
	Node* new_Node;
	AppLog("FileParser: Creating new Node with id 0");
			new_Node = new Node;//Create Node
			new_Node->Id = 0;
			new_Node->Coordinate.SetPosition(x1, y1);
			new_Node->IsCheckOut = false;//Not Check-out
			new_Node->IsJunction = true;//Real junction
	if(Nodes->Add(*new Integer(0), *new_Node)==E_SUCCESS)//Add the new node to the nodes
			AppLog("FileParser: Entrance Node added to the Nodes with id %d!", new_Node->Id.ToInt());

	int NodeId = 1;

	PExpectFromFile(Fajl,read,false,L"");

	bool more = false;

	if (read==L"CORRIDOR"){
		AppLog("%S token found", read.GetPointer());
		more = true;
	} else if (read==L"CHECKOUT"){
		AppLog("%S token found", read.GetPointer());
		more = false;
	} else {
		AppLog("*** %d: Invalid header!",ImportLineNumber);
		return E_INVALID_HEADER;
	}

	while(more){
		PParseCorridorFromFile(Fajl,NodeId);
		PExpectFromFile(Fajl,read,false,L"");
		if (read==L"CORRIDOR"){
				AppLog("%S token found", read.GetPointer());
				more = true;
			} else if (read==L"CHECKOUT"){
				AppLog("%S token found", read.GetPointer());
				more = false;
			} else {
				AppLog("*** %d: Invalid header!",ImportLineNumber);
				return E_INVALID_HEADER;
			}
	}
	//The shop must have at least one checkout
	more = true;
	while(more){
		//Read checkout coordinates
				r = Fajl->Read(sor);
				ImportLineNumber++;
					if (r!=E_SUCCESS){
						AppLog("*** %d: FileParser: Cannot read from file!",ImportLineNumber);
						return E_INVALID_FORMAT;
				}

			//Parse coordinates of checkout point
				StringTokenizer checkoutTokenizer(sor, L" ,\n\r\t\f");
				if (checkoutTokenizer.GetTokenCount()!=2){// int count != 2
						AppLog("*** %d: FileParser: 2 ints need for a coordinate!",ImportLineNumber);
						return E_INVALID_FORMAT;
				}

				String x1str, y1str;

				checkoutTokenizer.GetNextToken(x1str);
				checkoutTokenizer.GetNextToken(y1str);
			int x1, y1;
			if (Integer::Parse(x1str, x1)!=E_SUCCESS || Integer::Parse(y1str, y1)!=E_SUCCESS){//Check int validity
					AppLog("*** %d: FileParser: %S or %S not a valid int!", ImportLineNumber, x1str.GetPointer(), y1str.GetPointer());
					return E_INVALID_DATA;
				}
			Integer* checkout_id = new Integer;
			if((ContainsNodeByCoordinate(x1,y1,checkout_id))==true){
					AppLog("FileParser: (%d, %d) node already exists with id %d to be a checkout.", x1, y1, checkout_id->ToInt());
				} else {
					AppLog("*** %d: FileParser: Only an existing node can be converted to checkout, at (%d,%d) there is no node!", ImportLineNumber,x1, y1);
					return E_INVALID_DATA;
				}
			Node* new_Node;
			new_Node = static_cast<Node*>(Nodes->GetValue(*checkout_id));//Get the value of the existing node

			new_Node->IsJunction = true;//The node becomes a junction, no matter if it was or not
			new_Node->IsCheckOut = true;//The node becomes a checkout
			if(Checkouts->Add(*checkout_id)==E_SUCCESS)//Add the new node to the checkouts
					AppLog("FileParser: Checkout Node added to the Checkouts with id %d!", new_Node->Id.ToInt());


		//Is there more?
			PExpectFromFile(Fajl,read,false,L"");

			if (read==L"CHECKOUT"){
					AppLog("%S token found", read.GetPointer());
					more = true;
				} else if (read==L"END"){
					AppLog("%S token found", read.GetPointer());
					more = false;
				} else {
					AppLog("*** %d: Invalid header!",ImportLineNumber);
					return E_INVALID_HEADER;
				}
		}
	/*WriteNodes();
	WriteArchitectDistances();*/
	//WriteItems();

	return r;
}

Boolean shop::PExpectFromFile(File* Fajl, String& read, const Boolean check, const String expected, const String delimiters)
{
	String sor;
	String token;
	ImportLineNumber++;
	if (Fajl->Read(sor)!=E_SUCCESS){
		AppLog("*** %d: Cannot read from file!",ImportLineNumber);
		return false;
	}

	StringTokenizer tokenizer(sor, delimiters);
	tokenizer.GetNextToken(token);

	read = token;

	if (check==true && token!=expected){
			AppLog("*** %d: Read and expected data mismatch!",ImportLineNumber);
			return false;
	} else {
		return true;
	}

}

result shop::PParseItem(const String item_str, Item* item){
	result r = E_SUCCESS;

	StringTokenizer tokenizer(item_str, L",\n\r\t\f");

	if (tokenizer.GetTokenCount()!=2){
		AppLog("*** %d: ItemParser: Invalid item format!",ImportLineNumber);
		return E_INVALID_FORMAT;
	}

	String name, md;

	tokenizer.GetNextToken(name);
	tokenizer.GetNextToken(md);

	Boolean markdown(md);

	item->Name = name;
	item->Markdown = markdown.ToBool();
	item->Container = -1;

	return r;
}

Integer shop::PAddItemstoNode(const String items_row_str, Node* node){
	String token;
	int added = 0;
	if (IsGoodsinNode(items_row_str)==true)//If this node contains goods
			{
				StringTokenizer GoodsTokenizer(items_row_str, L";\n\r\t\f");
				while(GoodsTokenizer.HasMoreTokens()){//While there are still more goods
					GoodsTokenizer.GetNextToken(token);
					Item* new_item = new Item;//Create new item
					if (PParseItem(token, new_item)==E_SUCCESS){//If parsing the item was successful
						bool exists, contains;
						Goods->ContainsKey(new_item->Name, exists);//Check whether the Goods list already contains an item with this key
						contains = node->Stored.Contains(new_item->Name);//Check if the node contains that item
						if(contains==false && exists==false){//If both are false
							new_item->Container = node->Id;
							Goods->Add(new_item->Name, *new_item);//Add the item to the Goods list
							node->Stored.Add(new_item->Name);//Add to the container list
							added++;
						} else {
							delete new_item;
						}
					}
					else {
						AppLog("*** %d: Item adder: Item parsing error!",ImportLineNumber);
						return added;
					}
				}
			}
	return added;
}

result shop::PParseCorridorFromFile(File* Fajl, int& NodeId){
	result r = E_SUCCESS;
	String sor;
	String token;

	r = Fajl->Read(sor);
	ImportLineNumber++;
	if (r!=E_SUCCESS){
		AppLog("*** %d: CorridorParser: Cannot read from file!",ImportLineNumber);
		return E_INVALID_FORMAT;
	}

	StringTokenizer pointtokenizer(sor, L";\n\r\t\f");//Get the two points
	if (pointtokenizer.GetTokenCount()!=2){// point count != 2
		AppLog("*** %d: CorridorParser: 2 points need for a corridor!",ImportLineNumber);
		return E_INVALID_FORMAT;
	}

	String PointStr1, PointStr2;//Store the two points

	pointtokenizer.GetNextToken(PointStr1);
	pointtokenizer.GetNextToken(PointStr2);

	String x1str, y1str, x2str, y2str;

	//Parse coordinates of point1
	StringTokenizer coordinateTokenizer(PointStr1, L" ,\n\r\t\f");
	if (coordinateTokenizer.GetTokenCount()!=2){// int count != 2
			AppLog("*** %d: CorridorParser: 2 ints need for a coordinate!",ImportLineNumber);
			return E_INVALID_FORMAT;
	}

	coordinateTokenizer.GetNextToken(x1str);
	coordinateTokenizer.GetNextToken(y1str);


	//Parse coordinates of point2
	StringTokenizer coordinateTokenizer2(PointStr2, L" ,\n\r\t\f");
	if (coordinateTokenizer2.GetTokenCount()!=2){// int count != 2
			AppLog("*** %d: CorridorParser: 2 ints need for a coordinate!",ImportLineNumber);
			return E_INVALID_FORMAT;
	}

	coordinateTokenizer2.GetNextToken(x2str);
	coordinateTokenizer2.GetNextToken(y2str);

	int x1, y1, x2, y2;

	if (Integer::Parse(x1str, x1)!=E_SUCCESS || Integer::Parse(y1str, y1)!=E_SUCCESS){//Check int validity
		AppLog("*** CorridorParser: %S or %S not a valid int!", x1str.GetPointer(), y1str.GetPointer());
		return E_INVALID_DATA;
	}

	Osp::Graphics::Point* pont = new Osp::Graphics::Point(x1,y1);

	if (Base->Contains(*pont)==false){//Point in base check
		AppLog("*** CorridorParser: (%d,%d) coordinate out of Base!", x1, y1);
		return E_INVALID_DATA;
	}

	if (Integer::Parse(x2str, x2)!=E_SUCCESS || Integer::Parse(y2str, y2)!=E_SUCCESS){//Check int validity
		AppLog("*** CorridorParser: %S or %S not a valid int!", x2str.GetPointer(), y2str.GetPointer());
		return E_INVALID_DATA;
	}

	pont->SetPosition(x2,y2);

	if (Base->Contains(*pont)==false){//Point in base check
		AppLog("*** CorridorParser: (%d,%d) coordinate out of Base!", x2, y2);
		return E_INVALID_DATA;
	}

	Integer* node_id1 = new Integer;
	Integer* node_id5 = new Integer;

	//Get Node_ids if nodes exist

	if(ContainsNodeByCoordinate(x1,y1,node_id1)==true){
		//AppLog("CorridorParser: (%d, %d) node already exists with id %d", x1, y1, node_id1->ToInt());
	}

	if(ContainsNodeByCoordinate(x2,y2,node_id5)==true){
		//AppLog("CorridorParser: (%d, %d) node already exists with id %d", x2, y2, node_id5->ToInt());
	}

	//Check if at least one Node already exists
	/*if (node_id1->ToInt()==-1 && node_id5->ToInt()==-1){
		AppLog("*** CorridorParser: Isolated corridor at (%d,%d),(%d,%d)!",x1,y1,x2,y2);
		return E_INVALID_DATA;
	}*/

	Node* new_Node;
	if(node_id1->ToInt() == -1){//If it is a new node
		//AppLog("CorridorParser: Creating new Node with id %d", NodeId);
		new_Node = new Node;//Create Node
		new_Node->Id = NodeId;
		new_Node->Coordinate.SetPosition(x1, y1);
		new_Node->IsCheckOut = false;//Not Check-out
		new_Node->IsJunction = true;//Real junction
		*node_id1 = NodeId;//Store the id
		NodeId++;//Increment the node id
	} else {//If it is not a new node, get a pointer to the node to add items to it if needed
		new_Node = static_cast<Node*>(Nodes->GetValue(*node_id1));//Get the value of the existing node

		new_Node->IsJunction = true;//The node becomes a junction, no matter if it was or not
	}
		//Read goods stored in that node
		r = Fajl->Read(sor);
		ImportLineNumber++;
		if (r!=E_SUCCESS){
			AppLog("*** CorridorParser: Cannot read from file!");
			return E_INVALID_FORMAT;
		}
		Integer added = PAddItemstoNode(sor, new_Node);//Add items to that Node
		//AppLog("CorridorParser: %d new items added to node %d!", added.ToInt(), new_Node->Id.ToInt());

		if(Nodes->Add(*node_id1, *new_Node)==E_SUCCESS){//Add the new node to the nodes
			//AppLog("CorridorParser: Node added to the Nodes with id %d!", new_Node->Id.ToInt());
		}
		//Calculate the delta-coordinates

		Integer deltax, deltay;
		deltax = x2 - x1;
		deltay = y2 - y1;

		//Calculate the additive coordinate factor between two nodes
		int unitx, unity;
		unitx = Math::Round(deltax.ToFloat() / 4);
		unity = Math::Round(deltay.ToFloat() / 4);

		Node* prev_Node = new_Node;

		//Create 1. inner node
		//AppLog("CorridorParser: Creating new Node with id %d", NodeId);
		new_Node = new Node;//Create Node
		new_Node->Id = NodeId;
		new_Node->Coordinate.SetPosition(x1+unitx, y1+unity);
		new_Node->IsCheckOut = false;//Not Check-out
		new_Node->IsJunction = false;//Inner node
		Integer* node_id2 = new Integer(NodeId);//Store the node id
		NodeId++;//Increment the node id

		//Read goods stored in that node
		r = Fajl->Read(sor);
		ImportLineNumber++;
		if (r!=E_SUCCESS){
			AppLog("*** CorridorParser: Cannot read from file!");
			return E_INVALID_FORMAT;
		}
		added = PAddItemstoNode(sor, new_Node);//Add items to that Node
		//AppLog("CorridorParser: %d new items added to node %d!", added.ToInt(), new_Node->Id.ToInt());

		Nodes->Add(*node_id2, *new_Node);//Add the new node to the nodes
		//AppLog("CorridorParser: Node added to the Nodes with id %d!", new_Node->Id.ToInt());

		Double* distance = new Double(Distance(prev_Node->Coordinate, new_Node->Coordinate));//Calculate distance between nodes

		if(SetArchitectDistance(prev_Node->Id,new_Node->Id,*distance)!=E_SUCCESS){
			AppLog("*** CorridorParser: Error changing Architecture value!");
			return E_INVALID_ARG;
		}
		prev_Node = new_Node;



		//Create 2. inner node
		//AppLog("CorridorParser: Creating new Node with id %d", NodeId);
		new_Node = new Node;//Create Node
		new_Node->Id = NodeId;
		new_Node->Coordinate.SetPosition(x1+2*unitx, y1+2*unity);
		new_Node->IsCheckOut = false;//Not Check-out
		new_Node->IsJunction = false;//Inner node
		Integer* node_id3 = new Integer(NodeId);//Store the node id
		NodeId++;//Increment the node id

		//Read goods stored in that node
		r = Fajl->Read(sor);
		ImportLineNumber++;
		if (r!=E_SUCCESS){
			AppLog("*** CorridorParser: Cannot read from file!");
			return E_INVALID_FORMAT;
		}
		added = PAddItemstoNode(sor, new_Node);//Add items to that Node
		//AppLog("CorridorParser: %d new items added to node %d!", added.ToInt(), new_Node->Id.ToInt());

		Nodes->Add(*node_id3, *new_Node);//Add the new node to the nodes
		//AppLog("CorridorParser: Node added to the Nodes with id %d!", new_Node->Id.ToInt());

		distance = new Double(Distance(prev_Node->Coordinate, new_Node->Coordinate));//Calculate distance between nodes

		if(SetArchitectDistance(prev_Node->Id,new_Node->Id,*distance)!=E_SUCCESS){
			AppLog("*** CorridorParser: Error changing Architecture value!");
			return E_INVALID_ARG;
		}
		prev_Node = new_Node;

		//Create 3. inner node
		//AppLog("CorridorParser: Creating new Node with id %d", NodeId);
		new_Node = new Node;//Create Node
		new_Node->Id = NodeId;
		new_Node->Coordinate.SetPosition(x2-unitx, y2-unity);
		new_Node->IsCheckOut = false;//Not Check-out
		new_Node->IsJunction = false;//Inner node
		Integer* node_id4 = new Integer(NodeId);//Store the node id
		NodeId++;//Increment the node id

		//Read goods stored in that node
		r = Fajl->Read(sor);
		ImportLineNumber++;
		if (r!=E_SUCCESS){
			AppLog("*** CorridorParser: Cannot read from file!");
			return E_INVALID_FORMAT;
		}
		added = PAddItemstoNode(sor, new_Node);//Add items to that Node
		//AppLog("CorridorParser: %d new items added to node %d!", added.ToInt(), new_Node->Id.ToInt());

		Nodes->Add(*node_id4, *new_Node);//Add the new node to the nodes
		//AppLog("CorridorParser: Node added to the Nodes with id %d!", new_Node->Id.ToInt());

		distance = new Double(Distance(prev_Node->Coordinate, new_Node->Coordinate));//Calculate distance between nodes

		if(SetArchitectDistance(prev_Node->Id,new_Node->Id,*distance)!=E_SUCCESS){
			AppLog("*** CorridorParser: Error changing Architecture value!");
			return E_INVALID_ARG;
		}
		prev_Node = new_Node;

		//Create end of corridor

		if(node_id5->ToInt() == -1){//If it is a new node
			//AppLog("CorridorParser: Creating new Node with id %d", NodeId);
			new_Node = new Node;//Create Node
			new_Node->Id = NodeId;
			new_Node->Coordinate.SetPosition(x2, y2);
			new_Node->IsCheckOut = false;//Not Check-out
			new_Node->IsJunction = true;//Real junction
			*node_id5 = NodeId;//Store the id
			NodeId++;//Increment the node id
		} else {//If it is not a new node, get a pointer to the node to add items to it if needed
		new_Node = static_cast<Node*>(Nodes->GetValue(*node_id5));//Get the value of the existing node

		new_Node->IsJunction = true;//The node becomes a junction, no matter if it was or not
		}
		//Read goods stored in that node
		r = Fajl->Read(sor);
		ImportLineNumber++;
		if (r!=E_SUCCESS){
			AppLog("*** CorridorParser: Cannot read from file!");
			return E_INVALID_FORMAT;
		}
		added = PAddItemstoNode(sor, new_Node);//Add items to that Node
		//AppLog("CorridorParser: %d new items added to node %d!", added.ToInt(), new_Node->Id.ToInt());


		Nodes->Add(*node_id5, *new_Node);//Add the new node to the nodes
		//AppLog("CorridorParser: Node added to the Nodes with id %d!", new_Node->Id.ToInt());

		distance = new Double(Distance(prev_Node->Coordinate, new_Node->Coordinate));//Calculate distance between nodes

		if(SetArchitectDistance(prev_Node->Id,new_Node->Id,*distance)!=E_SUCCESS){
			AppLog("*** CorridorParser: Error changing Architecture value!");
			return E_INVALID_ARG;
		}

		//AppLog("###################################");


	return r;
}

Boolean shop::ContainsNodeByCoordinate(const int x, const int y, Integer* node_id){

	Boolean found(false);
	*node_id = -1;
	Node* curr;
	IMapEnumerator* enumerator = Nodes->GetMapEnumeratorN();
	enumerator->Reset();
	while (found==false && enumerator->MoveNext()==E_SUCCESS){
		curr = static_cast<Node*>(enumerator->GetValue());
		if (curr->Coordinate.x==x && curr->Coordinate.y==y){
			found = true;
			*node_id = static_cast<Integer*>(enumerator->GetKey())->ToInt();
		}
	}


	delete enumerator;
	return found;

}

Boolean shop::IsGoodsinNode(const String goods_str){
	StringTokenizer token(goods_str, L";\n\r\t\f");
	String t;
	token.GetNextToken(t);
	if (token.GetTokenCount()<=1 && (t==L"NULL" || t.IsEmpty()))
		return false;
	else
		return true;
}


result shop::SetArchitectDistance(const Integer i, const Integer j, const Double distance){
	result r = E_SUCCESS;
	bool exists;
	HashMap* valuemap;
	Double* distvalue = new Double(distance);
	Integer* ivalue = new Integer(i);
	Integer* jvalue = new Integer(j);
	//VICA
	Architecture->ContainsKey(*ivalue, exists);
	if (exists==false){//If the first index not exists
		valuemap = new HashMap;
		valuemap->Construct();
		r = Architecture->Add(*ivalue, *valuemap);
		if (r!=E_SUCCESS){
			AppLog("Error adding first index list to Architecture!");
			return r;
		}
	}
	valuemap = static_cast<HashMap*>(Architecture->GetValue(*ivalue));
	valuemap->ContainsKey(*jvalue,exists);
	if (exists == false){//If the second index not exists
		r = valuemap->Add(*jvalue, *distvalue);
		if (r!=E_SUCCESS){
				AppLog("Error adding second index value to Architecture!");
				return r;
			}
	} else {//If both indexes exist
		r = valuemap->SetValue(*jvalue, *distvalue, true);
		if (r!=E_SUCCESS){
				AppLog("Error changing value in Architecture!");
				return r;
		}
	}
	//VERSA
	distvalue = new Double(distance);
	Architecture->ContainsKey(*jvalue, exists);
		if (exists==false){//If the first index not exists
			valuemap = new HashMap;
			valuemap->Construct();
			r = Architecture->Add(*jvalue, *valuemap);
			if (r!=E_SUCCESS){
				AppLog("Error adding first index list to Architecture!");
				return r;
			}
		}
		valuemap = static_cast<HashMap*>(Architecture->GetValue(j));
		valuemap->ContainsKey(*ivalue,exists);
		if (exists == false){//If the second index not exists
			r = valuemap->Add(*ivalue, *distvalue);
			if (r!=E_SUCCESS){
					AppLog("Error adding second index value to Architecture!");
					return r;
				}
		} else {//If both indexes exist
			r = valuemap->SetValue(*ivalue, *distvalue, true);
			if (r!=E_SUCCESS){
					AppLog("Error changing value in Architecture!");
					return r;
			}
		}
	return r;
}

void shop::WriteArchitectDistances(void){

	IMapEnumerator* kulso = Architecture->GetMapEnumeratorN();
	kulso->Reset();
	while(kulso->MoveNext()==E_SUCCESS){
		Integer* kulsokulcs;
		kulsokulcs = static_cast<Integer*>(kulso->GetKey());
		HashMap* kulsoertek;
		kulsoertek = static_cast<HashMap*>(kulso->GetValue());
		IMapEnumerator* belso = kulsoertek->GetMapEnumeratorN();
		belso->Reset();
		while(belso->MoveNext()==E_SUCCESS){
			Integer* belsokulcs = static_cast<Integer*>(belso->GetKey());
			Double* belsoertek = static_cast<Double*>(belso->GetValue());
			AppLog("Architecture[%d][%d]=%f",kulsokulcs->ToInt(),belsokulcs->ToInt(),belsoertek->ToDouble());
		}
		delete belso;
	}
	delete kulso;
}

bool shop::IsCartItemstInShop(void){
	bool r = true;
	if (Navigation==null){
		AppLog("***CartItemsInShop: Navigation is null!");
		return false;
	}
	IList* GoodsNames = Goods->GetKeysN();
	GoodsNames->ContainsAll(*Navigation->Cart, r);
	delete GoodsNames;
	return r;
}

void shop::WriteItems(void){
	IMapEnumerator* goodenum = Goods->GetMapEnumeratorN();
	goodenum->Reset();
	AppLog("Goods count: %d", Goods->GetCount());
	while(goodenum->MoveNext()==E_SUCCESS){
		AppLog("     %S in %d",static_cast<String*>(goodenum->GetKey())->GetPointer(),static_cast<Item*>(goodenum->GetValue())->Container.ToInt());
	}
	delete goodenum;
}

void shop::WriteNodes(void){
	IMapEnumerator* nodeenum = Nodes->GetMapEnumeratorN();
	nodeenum->Reset();
	AppLog("Nodes count: %d", Nodes->GetCount());
	while(nodeenum->MoveNext()==E_SUCCESS){
		Integer* id = static_cast<Integer*>(nodeenum->GetKey());
		String role;
		String checkout = L"";
		Node* n = static_cast<Node*>(nodeenum->GetValue());
		if(n->IsJunction==true){
			role = L"Junction";
		} else {
			role = L"Inner";
		}
		if(n->IsCheckOut==true){
			checkout = L"Checkout";
		}
		AppLog("Node %d. (%d,%d), %S, %S",id->ToInt(), n->Coordinate.x, n->Coordinate.y,role.GetPointer(),checkout.GetPointer());
	}
	delete nodeenum;
}

double shop::Distance(const Osp::Graphics::Point& point1, const Osp::Graphics::Point& point2){
	double deltax = (double)(point1.x-point2.x);
	double deltay = (double)(point1.y-point2.y);
	double res = Math::Sqrt(Math::Pow(deltax,2)+Math::Pow(deltay,2));
	return res;
}

result shop::SaveInfoToFile(File* Fajl)
{
	result r = E_SUCCESS;

	r = Fajl->Write(L"SHOP INFORMATION\r\n");
	if(r==E_SUCCESS){
		r = Fajl->Write(Name);
		r = Fajl->Write(L"\r\n");
	}
	if(r==E_SUCCESS){
			r = Fajl->Write(Address);
			r = Fajl->Write(L"\r\n");
	}
	if(r==E_SUCCESS){
			r = Fajl->Write(Integer::ToString(Base->width));
			r = Fajl->Write(L"\r\n");
			r = Fajl->Write(Integer::ToString(Base->height));
			r = Fajl->Write(L"\r\n");
	}

	return r;
}

result shop::LoadInfoFromFile(File* Fajl)
{
	result r = E_SUCCESS;
	String sor;
	r = Fajl->Read(sor);
	PExpectFromFile(Fajl, Name, false, L"", L"\r\n");
	PExpectFromFile(Fajl, Address, false, L"", L"\r\n");
	PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
	int x, y;
	r = Integer::Parse(sor, x);
	if(r!=E_SUCCESS)
		return r;
	PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
	r = Integer::Parse(sor, y);
	if(r!=E_SUCCESS)
			return r;
	Base->SetBounds(0,0,x,y);
	return r;
}

result shop::SaveItemsToFile(File* Fajl)
{
	result r = E_SUCCESS;
	r = Fajl->Write(L"GOODS\r\n");

	IMapEnumerator* goodenum = Goods->GetMapEnumeratorN();
	goodenum->Reset();
	if (r ==E_SUCCESS)
	{
		r = Fajl->Write(Integer::ToString(Goods->GetCount()));
		r = Fajl->Write(L"\r\n");
	}
	while(goodenum->MoveNext()==E_SUCCESS && r == E_SUCCESS){
		if(r==E_SUCCESS)
		Fajl->Write(*static_cast<String*>(goodenum->GetKey()));
		if(r==E_SUCCESS)
		Fajl->Write(L"\r\n");
		if(r==E_SUCCESS)
		Fajl->Write(static_cast<Item*>(goodenum->GetValue())->Container.ToString());
		if(r==E_SUCCESS)
		Fajl->Write(L"\r\n");
	}
	delete goodenum;

	return r;
}

result shop::LoadItemsFromFile(File* Fajl)
{
	result r = E_SUCCESS;
	Goods->RemoveAll(true);
	String sor;
	r = Fajl->Read(sor);
	if(r!=E_SUCCESS)
		return r;
	PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
	int count;
	r = Integer::Parse(sor, count);
	if(r!=E_SUCCESS)
		return r;
	for(int i=1; i<=count; i++){
		Item* item = new Item;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		item->Name = sor;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		int container;
		r = Integer::Parse(sor, container);
		if(r!=E_SUCCESS)
			return r;
		item->Container = container;
		item->Markdown = false;
		r = Goods->Add(*new String(item->Name),*item);
	}

	return r;
}

result shop::SaveNodesToFile(File* Fajl)
{
	result r = E_SUCCESS;
	r = Fajl->Write(L"NODES\r\n");

	IMapEnumerator* nodeenum = Nodes->GetMapEnumeratorN();
	nodeenum->Reset();
	if (r ==E_SUCCESS)
	{
		r = Fajl->Write(Integer::ToString(Nodes->GetCount()));
		r = Fajl->Write(L"\r\n");
	}

	while(nodeenum->MoveNext()==E_SUCCESS){
		if (r ==E_SUCCESS)
		{
			r = Fajl->Write(static_cast<Integer*>(nodeenum->GetKey())->ToString());
			r = Fajl->Write(L"\r\n");
		}
		Node* n = static_cast<Node*>(nodeenum->GetValue());
		if (r ==E_SUCCESS)
		{
			r = Fajl->Write(Integer::ToString(n->Coordinate.x));
			r = Fajl->Write(L"\r\n");
			r = Fajl->Write(Integer::ToString(n->Coordinate.y));
			r = Fajl->Write(L"\r\n");
		}
		if (r ==E_SUCCESS)
		{
			r = Fajl->Write(Boolean::ToString(n->IsJunction));
			r = Fajl->Write(L"\r\n");
			r = Fajl->Write(Boolean::ToString(n->IsCheckOut));
			r = Fajl->Write(L"\r\n");
		}
		if (r ==E_SUCCESS)
		{
			Fajl->Write(Integer::ToString(n->Stored.GetCount()));
			Fajl->Write(L"\r\n");
			if (n->Stored.GetCount()>0){
				IEnumerator* enumStored = n->Stored.GetEnumeratorN();
				enumStored->Reset();
				while(enumStored->MoveNext()==E_SUCCESS){
					Fajl->Write(*static_cast<String*>(enumStored->GetCurrent()));
					Fajl->Write(L"\r\n");
				}
				delete enumStored;
			}
		}

	}
	delete nodeenum;

	return r;
}

result shop::LoadNodesFromFile(File* Fajl)
{
	Nodes->RemoveAll(true);
	result r = E_SUCCESS;
	String sor;
	int number;
	r = Fajl->Read(sor);
	if(r!=E_SUCCESS)
		return r;
	PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
	int count;
	r = Integer::Parse(sor, count);
	if(r!=E_SUCCESS)
		return r;
	for(int i=1; i<=count; i++){
		Node* node = new Node;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		r = Integer::Parse(sor, number);
		if(r!=E_SUCCESS)
			return r;
		node->Id = number;
		int x, y;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		r = Integer::Parse(sor, x);
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		r = Integer::Parse(sor, y);
		node->Coordinate.SetPosition(x,y);
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		node->IsJunction = Boolean::Parse(sor);
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		node->IsCheckOut = Boolean::Parse(sor);
		int storedcount;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		r = Integer::Parse(sor, storedcount);
		if(r!=E_SUCCESS)
					return r;
		for(int j=1;j<=storedcount;j++){
			PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
			node->Stored.Add(*new String(sor));
		}
		r = Nodes->Add(*new Integer(node->Id),*node);
		if(r!=E_SUCCESS)
			return r;
	}

	return r;
}

result shop::SaveCheckoutsToFile(File* Fajl)
{
	result r = E_SUCCESS;
	r = Fajl->Write(L"CHECKOUTS\r\n");
	if(r == E_SUCCESS){
		r = Fajl->Write(Integer::ToString(Checkouts->GetCount()));
		Fajl->Write(L"\r\n");
		IEnumerator* enumCheckouts = Checkouts->GetEnumeratorN();
		enumCheckouts->Reset();
		while(enumCheckouts->MoveNext()==E_SUCCESS){
			r = Fajl->Write(static_cast<Integer*>(enumCheckouts->GetCurrent())->ToString());
			Fajl->Write(L"\r\n");
		}

		delete enumCheckouts;
	}

	return r;
}

result shop::LoadCheckoutsFromFile(File* Fajl)
{
	Checkouts->RemoveAll(true);
	result r = E_SUCCESS;
	String sor;
	r = Fajl->Read(sor);
	if(r!=E_SUCCESS)
		return r;
	int count;
	PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
	r = Integer::Parse(sor, count);
	if(r!=E_SUCCESS)
		return r;
	for(int i=1;i<=count;i++){
		int number;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		r = Integer::Parse(sor, number);
		if(r!=E_SUCCESS)
			return r;
		r = Checkouts->Add(*new Integer(number));
		if(r!=E_SUCCESS)
			return r;
	}
	return r;
}

result shop::SaveArchitectureToFile(File* Fajl)
{
	result r = E_SUCCESS;
	r = Fajl->Write(L"ARCHITECTURE\r\n");
	if(r == E_SUCCESS){

		IMapEnumerator* kulso = Architecture->GetMapEnumeratorN();
		kulso->Reset();
		while(kulso->MoveNext()==E_SUCCESS){
			Integer* kulsokulcs;
			kulsokulcs = static_cast<Integer*>(kulso->GetKey());
			HashMap* kulsoertek;
			kulsoertek = static_cast<HashMap*>(kulso->GetValue());
			IMapEnumerator* belso = kulsoertek->GetMapEnumeratorN();
			belso->Reset();
			while(belso->MoveNext()==E_SUCCESS){
				Integer* belsokulcs = static_cast<Integer*>(belso->GetKey());
				Double* belsoertek = static_cast<Double*>(belso->GetValue());
				Fajl->Write(L"NEXT");
				Fajl->Write(L"\r\n");
				Fajl->Write(kulsokulcs->ToString());
				Fajl->Write(L"\r\n");
				Fajl->Write(belsokulcs->ToString());
				Fajl->Write(L"\r\n");
				Fajl->Write(belsoertek->ToString());
				Fajl->Write(L"\r\n");
			}
			delete belso;
		}
		delete kulso;
	}

	return r;
}

result shop::LoadArchitectureFromFile(File* Fajl)
{
	Architecture->RemoveAll(true);
	result r = E_SUCCESS;
	String sor;
	r = Fajl->Read(sor);
	if(r!=E_SUCCESS)
		return r;
	while(Fajl->Read(sor)==E_SUCCESS){
		int kulso, belso;
		double ertek;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		r = Integer::Parse(sor, kulso);
		if(r!=E_SUCCESS)
			return r;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		r = Integer::Parse(sor, belso);
		if(r!=E_SUCCESS)
			return r;
		PExpectFromFile(Fajl, sor, false, L"", L"\r\n");
		r = Double::Parse(sor, ertek);
		if(r!=E_SUCCESS)
			return r;
		r = SetArchitectDistance(kulso,belso,ertek);
		if(r!=E_SUCCESS)
			return r;
	}

	return r;
}

result shop::MoveItem(const String what, const String where)
{
	result r = E_SUCCESS;
	Integer whatId, whereId;
	Item* whatItem, *whereItem;
	Node* whatNode, *whereNode;
	whatItem = static_cast<Item*>(Goods->GetValue(what));
	whereItem = static_cast<Item*>(Goods->GetValue(where));

	whatId = whatItem->Container;
	whereId = whereItem->Container;

	whatNode = static_cast<Node*>(Nodes->GetValue(whatId));
	whereNode = static_cast<Node*>(Nodes->GetValue(whereId));

	//Modify the nodes

	r = whatNode->Stored.Remove(what,true);
	if (r == E_SUCCESS)
	r = whereNode->Stored.Add(*new String(what));

	//Modify the good

	whatItem->Container = whereId;

	return r;

}

result shop::DeleteItem(const String item)
{
	result r = E_SUCCESS;
	Integer whatId;
	Item* whatItem;
	Node* whatNode;

	whatItem = static_cast<Item*>(Goods->GetValue(item));
	whatId = whatItem->Container;

	whatNode = static_cast<Node*>(Nodes->GetValue(whatId));
	//Modify the node
	r = whatNode->Stored.Remove(item,true);
	//Delete the good
	Goods->Remove(item,true);

	return r;
}

result shop::NewItem(const String name, const String place)
{
	result r = E_SUCCESS;
	bool exist = false;
	Goods->ContainsKey(name, exist);
	if(exist){
		return E_OBJ_ALREADY_EXIST;
	}

	Integer placeId;
	Item* placeItem;
	Node* placeNode;

	placeItem = static_cast<Item*>(Goods->GetValue(place));
	placeId = placeItem->Container;

	placeNode = static_cast<Node*>(Nodes->GetValue(placeId));
	//Modify the node
	r = placeNode->Stored.Add(*new String(name));
	//Add the good
	Item* new_item = new Item;
	new_item->Container = placeId;
	new_item->Markdown = false;
	new_item->Name = name;

	r = Goods->Add(*new String(name),*new_item);

	return r;
}


